Require Import ssreflect ssrbool ssrnat eqtype fintype seq funs ssralg ssrbig matrix.
(* ssrbool funs eqtype ssrnat seq fintype.
Require Import tuple paths connect div .
Require Import groups group_perm zp ssralg ssrbig matrix.
*)
Require Import structRp min_max.
Require Import Reals.
Require Import Fourier.
Require Import Ranalysis.
Require Import Classical.
Require Import ClassicalChoice.
Require Import vectors seqRp funRp matrixRp matrixNorm.
Require Import Max.

Lemma Rmult_eq_reg_r:
forall r r1 r2, r1*r = r2*r-> r<>0-> r1 = r2.
Proof.
move => r r1 r2 H H1.
rewrite (Rmult_comm r1 r) (Rmult_comm r2 r) in H.
by apply  Rmult_eq_reg_l with r.
Qed.

(*
Fixpoint derivative (n: nat) (f:R->R) (x:R) {struct n} :=
match n with
| O => f x
| S O => derive_pt f x (pr (S O) f x)
| S n' => derive_pt (derivative n' f x pr) x (pr n' f x)
end.

not a very bright idea
*)


Theorem Taylor2:
forall (a b:R)(f f' f'':R->R) 
(pr: forall x:R, a<=x<=b -> derivable_pt f x)
(prc: forall x:R, a<=x<=b -> continuity_pt f' x)
(prf':forall x, (a<x<b) -> derivable_pt f' x),
(forall (x:R)(H:a<=x<=b), derive_pt f x (pr x H)=f' x) ->
(forall (x:R)(H':a<x<b), derive_pt f' x (prf' x H')=f'' x) ->
(forall t t0, a<=t<=b -> a<t0<b-> t<>t0->
exists c, (t<c<t0\/t0<c<t)/\(f t = f t0 + (f' t0)*(t-t0)+ (f'' c)*(Rsqr (t-t0))/2)).
Proof.
move => a b f f' f'' pr prc prf'  Heqf Heqf' t t0 Ht Ht0 Htt0.
have Htot: (t<t0 \/t>t0).
elim (Rtotal_order t t0) => H.
left; done.
right.
elim H => H1.
by elim Htt0.
done.
elim Htot => Htleq.
have prt: forall x, t<x<t0-> derivable_pt (fun s:R => (f t) - (f s) - (f' s)*(t-s)) x.
have H0: forall x, t<x<t0-> derivable_pt f x.
move => x Htx.
have H1: a<=x<=b.
elim Ht => H2 H3; elim Ht0 =>H4 H5; elim Htx => H6 H7; split; fourier. 
by apply (pr x H1).
have H2: forall x, t<x<t0-> derivable_pt f' x.
move => x Htx.
have H: a<x<b.
elim Ht => H2 H3; elim Ht0 =>H4 H5; elim Htx => H6 H7; split; fourier. 
by apply (prf' x H).
move => x Htx; reg.
by apply (H2 x Htx).
by apply (H0 x Htx).
have Hq: forall x, t<x<t0 -> derivable_pt (fun s:R=>Rsqr (s-t)) x.
move => x Htx; reg.
have Hcont1: forall x, t<=x<=t0 -> continuity_pt  (fun s:R => (f t) - (f s) - (f' s)*(t-s)) x.
move=> x Htx.
have H1: a<=x<=b.
elim Ht => H2 H3; elim Ht0 =>H4 H5; elim Htx => H6 H7; split; fourier. 
reg.
apply (prc x H1).
apply derivable_continuous_pt.
apply (pr x H1).
have Hcont2: forall x, t<=x<=t0 ->continuity_pt (fun s:R=>Rsqr (s-t)) x.
move =>x Htx; reg.
elim (MVT (fun s : R => (f t - f s - f' s * (t - s))%R) 
   (fun s : R => Rsqr (s - t)) t t0 prt Hq Htleq Hcont1 Hcont2)=> c Hmvt1.
elim Hmvt1 => P Heq.
exists c.
split.
by left.
replace (t-t) with R0 in Heq; [|ring].
rewrite Rsqr_0 Rminus_0_r Rmult_0_r  Rminus_0_r   in Heq.
replace (f t - f t) with R0 in Heq; [|ring].
 rewrite Rminus_0_r in Heq.
have Habc: a<=c<=b.
elim Ht => H2 H3; elim Ht0 =>H4 H5; elim P => H6 H7; split; fourier. 
have Habc': a<c<b.
elim Ht => H2 H3; elim Ht0 =>H4 H5; elim P => H6 H7; split; fourier. 
have Heq1: derive_pt (fun s : R => (f t - f s - f' s * (t - s))%R) c (prt c P) = 
- f' c -(f'' c)* (t-c)+(f' c).
reg.
rewrite (pr_nu f c H (pr c Habc)) (Heqf c Habc).
rewrite (pr_nu f' c H0 (prf' c Habc')) (Heqf' c Habc').
ring.
apply (prf' c Habc').
apply (pr c Habc).
have Heq2:  derive_pt (fun s : R => Rsqr (s - t)) c (Hq c P) = 2* (c-t).
reg.
rewrite Heq1 Heq2 in Heq.
replace (- f' c - f'' c * (t - c) + f' c) with ((f'' c)*(c-t)) in Heq; [|ring].
rewrite -Rmult_assoc -Rmult_assoc in Heq.
have P1: c-t<>0.
apply Rgt_not_eq.
elim P=> P2 P3; by apply: Rgt_minus.
have Heq3:= (Rmult_eq_reg_r (c-t) 
   (Rsqr (t0 - t) * f'' c) ((f t - f t0 - f' t0 * (t - t0)) * 2) Heq P1) .
pattern Rmult at 1; rewrite Rmult_comm.
rewrite Rsqr_neg_minus Heq3.
field.

have prt: forall x, t0<x<t-> derivable_pt (fun s:R => (f t) - (f s) - (f' s)*(t-s)) x.
have H0: forall x, t0<x<t-> derivable_pt f x.
move => x Htx.
have H1: a<=x<=b.
elim Ht => H2 H3; elim Ht0 =>H4 H5; elim Htx => H6 H7; split; fourier. 
by apply (pr x H1).
have H2: forall x, t0<x<t-> derivable_pt f' x.
move => x Htx.
have H: a<x<b.
elim Ht => H2 H3; elim Ht0 =>H4 H5; elim Htx => H6 H7; split; fourier. 
by apply (prf' x H).
move => x Htx; reg.
by apply (H2 x Htx).
by apply (H0 x Htx).
have Hq: forall x, t0<x<t -> derivable_pt (fun s:R=>Rsqr (s-t)) x.
move => x Htx; reg.
have Hcont1: forall x, t0<=x<=t -> continuity_pt  (fun s:R => (f t) - (f s) - (f' s)*(t-s)) x.
move=> x Htx.
have H1: a<=x<=b.
elim Ht => H2 H3; elim Ht0 =>H4 H5; elim Htx => H6 H7; split; fourier. 
reg.
apply (prc x H1).
apply derivable_continuous_pt.
apply (pr x H1).
have Hcont2: forall x, t0<=x<=t ->continuity_pt (fun s:R=>Rsqr (s-t)) x.
move =>x Htx; reg.
elim (MVT (fun s : R => (f t - f s - f' s * (t - s))%R) 
   (fun s : R => Rsqr (s - t)) t0 t prt Hq Htleq Hcont1 Hcont2)=> c Hmvt1.
elim Hmvt1 => P Heq.
exists c.
split.
by right.
replace (t-t) with R0 in Heq; [|ring].
rewrite Rsqr_0 Rminus_0_l Rmult_0_r  Rminus_0_r  in Heq.
replace (f t - f t) with R0 in Heq; [|ring].
 rewrite Rminus_0_l in Heq.
have Habc: a<=c<=b.
elim Ht => H2 H3; elim Ht0 =>H4 H5; elim P => H6 H7; split; fourier. 
have Habc': a<c<b.
elim Ht => H2 H3; elim Ht0 =>H4 H5; elim P => H6 H7; split; fourier. 
have Heq1: derive_pt (fun s : R => (f t - f s - f' s * (t - s))%R) c (prt c P) = 
- f' c -(f'' c)* (t-c)+(f' c).
reg.
rewrite (pr_nu f c H (pr c Habc)) (Heqf c Habc).
rewrite (pr_nu f' c H0 (prf' c Habc')) (Heqf' c Habc').
ring.
apply (prf' c Habc').
apply (pr c Habc).
have Heq2:  derive_pt (fun s : R => Rsqr (s - t)) c (Hq c P) = 2* (c-t).
reg.
rewrite Heq1 Heq2 in Heq.
replace (- f' c - f'' c * (t - c) + f' c) with ((f'' c)*(c-t)) in Heq; [|ring].
rewrite -Rmult_assoc -Rmult_assoc in Heq.
have P1: c-t<>0.
apply Rlt_not_eq.
by elim P=> P2 P3; apply Rlt_minus.
have Heq3:= (Rmult_eq_reg_r (c-t)  (-Rsqr (t0 - t) * f'' c) 
  (-(f t - f t0 - f' t0 * (t - t0)) * 2) Heq P1) .
pattern Rmult at 1; rewrite Rmult_comm Rsqr_neg_minus .
replace ( Rsqr (t0 - t) * f'' c / 2) with (- (- Rsqr (t0 - t) * f'' c / 2)); [|field].
rewrite Heq3.
field.
Qed.


Lemma Taylor2_v2:
forall (f:R->R) 
(pr: forall x:R,  derivable_pt f x)
(prc: forall x:R,  continuity_pt (fun y=> derive_pt f y (pr y))  x)
(prf':forall x,  derivable_pt (fun y => derive_pt f y (pr y)) x),
(forall t t0, t0<t->
exists c, t0<c<t /\ (f t = f t0 + (derive_pt f t0 (pr t0))*(t-t0)+ 
(derive_pt (fun y => derive_pt f y (pr y)) c (prf' c))*(Rsqr (t-t0))/2)).
Proof.
move=> f pr Hc Hd t t0 Ht.
have pr0 : forall x : R, (t0 - R1) <= x <= (t+1) -> derivable_pt f x.
 by move=>*;apply pr.
have HcT: forall x : R,
      (t0-R1) <= x <= (t+R1) -> continuity_pt (fun y : R => derive_pt f y (pr y)) x .
by move=>*; apply Hc.
have  prf' : forall x : R,
              (t0-R1) < x < (t+R1) -> derivable_pt (fun y : R => derive_pt f y (pr y)) x.
by move=>*; apply Hd.
have Heq1: forall (x : R) (H : (t0-R1) <= x <= (t+R1)),
      derive_pt f x (pr0 x H) = derive_pt f x (pr x).
by move=>*; apply pr_nu.
have Heq2: forall (x : R) (H' : (t0-R1) < x < t+R1),
      derive_pt (fun y : R => derive_pt f y (pr y)) x (prf' x H') =
      derive_pt (fun y : R => derive_pt f y (pr y)) x (Hd x) .
by move=>*; apply pr_nu.
have Ht1: t0-R1<=t<=t+R1.
split; fourier.
have Ht2: t0-R1<t0<t+R1.
split; fourier.
have Ht3:t<>t0.
by apply Rgt_not_eq.
elim (Taylor2 (t0-R1) (t+R1) f (fun y => derive_pt f y (pr y)) 
(fun z => derive_pt (fun y=> derive_pt f y (pr y)) z (Hd z)) 
pr0 HcT prf' Heq1 Heq2 t t0 Ht1 Ht2 Ht3) => c [Hc1 Hc2].
exists c; split; last by exact Hc2.
elim Hc1 => H0;[|done].
have H1: t<t0.
 elim H0 => *; apply Rlt_trans with c; assumption.
have H2: t0<=t.
by left.
by elim (RIneq.Rle_not_lt _ _ H2).
Qed.

(*about derivatives in one dimension*)

Lemma pr_eq_f:
forall f h t, 
(forall x , f x = h x) ->
derivable_pt f t  -> 
derivable_pt h t.
Proof.
move => f h x Heq Hd.
elim Hd => l Hl.
exists l.
rewrite /derivable_pt_abs /derivable_pt_lim in Hl |-* => eps He.
elim (Hl eps He) => del Hlim.
exists del => t Ht.
rewrite -(Heq (x+t)) -(Heq x).
exact (Hlim  t Ht).
Qed.



Lemma eq_der_f:
forall (f h:R->R) t pr
(H:forall x , f x = h x),
derive_pt f t pr = derive_pt h t (pr_eq_f f h t H pr).
Proof.
move => f h t pr H.

case (pr_eq_f f h t H pr).
rewrite //=.
case pr.
rewrite //=.
move => x0 H1 x1 H2.
rewrite /derivable_pt_abs /derivable_pt_lim in H1 H2.

have Heq: forall  eps : R,
        0 < eps ->  Rabs (x1 - x0) <eps.
move => eps He.
elim (H1 (eps*/2)(eps2_Rgt_R0 eps He)) => del1  Hrel1.
elim (H2 (eps*/2)(eps2_Rgt_R0 eps He)) => del2 Hrel2.
have  H0 : 0 < Rmin del1 del2.
apply Rmin_Rgt_r; split.
exact (cond_pos del1).
exact (cond_pos del2).
have H3:0< (Rmin del1 ( del2)) /2.
by apply: eps2_Rgt_R0.
have Hineq1: 0< Rabs (Rmin del1 del2 / 2 )<del1.
split; rewrite Rabs_right; first by done.
by rewrite /Rge; left.
apply Rlt_le_trans with (Rmin del1 del2).
by rewrite /Rdiv ;apply Rlt_eps2_eps .
by apply Rmin_l.
by rewrite /Rge; left.
have Hineq22: Rabs (Rmin del1 del2 / 2)< del2.
rewrite Rabs_right .
apply Rlt_le_trans with (Rmin del1 del2).
by rewrite /Rdiv ;apply Rlt_eps2_eps .
by apply Rmin_r.
by rewrite /Rge; left.
have Hineq21: Rmin del1 del2 / 2<>0. 
by apply Rgt_not_eq.
have Hrel1':= (Hrel1 (Rmin del1 del2 / 2) Hineq21).
have Hrel2':= Hrel2 (Rmin del1 del2 / 2) Hineq21 Hineq22.
rewrite Rabs_minus_sym in Hrel2'.
replace eps with (eps*/2+eps*/2)%R; [|field].
replace (x1-x0)%R with ((x1-  (h (t + Rmin del1 del2 / 2) - h t) / (Rmin del1 del2 / 2)) +
 ((h (t + Rmin del1 del2 / 2) - h t) / (Rmin del1 del2 / 2) -x0))%R;[|field].
apply Rle_lt_trans with (Rabs (x1-  (h (t + 
     Rmin del1 del2 / 2) - h t) / (Rmin del1 del2 / 2)) +
 Rabs ((h (t + Rmin del1 del2 / 2) - h t) / (Rmin del1 del2 / 2) -x0)).
apply Rabs_triang.
 apply Rplus_lt_compat.
exact Hrel2'.
 rewrite -(H (t + Rmin del1 del2 / 2)) -(H t).
have H5: Rabs (Rmin del1 del2 / 2) < del1 by elim Hineq1.

exact (Hrel1' H5).
by apply Rgt_not_eq.
have H01:= (prop_eps ( Rabs (x1 - x0)) Heq).
have H0':= Rabs_pos (x1-x0).
have H3: Rabs (x1-x0)=0.
by apply Rle_antisym.
 fold (R_dist x1 x0) in H3. 
by rewrite R_dist_refl in H3.
Qed.

Lemma lim_der_eq:
forall (f h:R->R) t l,
(forall x , f x = h x)->

derivable_pt_lim f t l  -> 
derivable_pt_lim h t l.
Proof.
move => f h t l Heq Hd.
rewrite  /derivable_pt_lim in Hd |-* => eps He.
elim (Hd eps He) => del Hlim.
exists del => y Hy.
rewrite -(Heq (t+y)) -(Heq t).
exact (Hlim  y Hy).
Qed.

Lemma fun_eq_der_eq:
forall f g t prf prg,
(forall x, f x = g x) ->
derive_pt f t prf = derive_pt g t prg.
Proof.
move=> f g t prf prg H.
elim (derivable_derive g t prg) => l Hl.
rewrite Hl.
apply derive_pt_eq_0.
apply lim_der_eq with g; [by move=> x; rewrite H|by apply derive_pt_eq_1 with prg].
Qed.


Lemma lim_der_eq2:
forall (f f2:R->R) x l,
(forall x , f x = f2 x)->
 ( forall eps : R,   0 < eps ->   exists delta : posreal,
     forall h : R,     h <> 0 ->     Rabs h < delta ->
     Rabs ((f (x + h)  - f x) / h - l) < eps)
-> ( forall eps : R,   0 < eps ->   exists delta : posreal,
     forall h : R,     h <> 0 ->     Rabs h < delta ->
     Rabs ((f2 (x + h)  - f2 x) / h - l) < eps).
Proof.
move => f h t l Heq Hd eps He.
elim (Hd eps He) => del Hlim.
exists del => y Hy.
rewrite -(Heq (t+y)) -(Heq t).
exact (Hlim  y Hy).
Qed.

(*talking about second order derivatives in R ....*)



Section deriv.
Variable p: pos_nat.
Lemma Hp: (O<p)%nat.
Proof.
have Hp1:= pos_natP p.
move/leP:Hp1=>Hp1.
omega.
Qed.


Notation "v1 +^ v2" := (add_v v1 v2) (at level 50).
Notation "a *^ v" := (mult_sv a v) (at level 40).
Notation "v1 -^ v2" := (dif_v v1 v2) (at level 50).
Notation "-^ v" := (opp_v v) (at level 35).

Delimit Scope ring_scope with Ri.
(*now trying to move on to differenitation: partial derivatives and
other diff. concepts.

we start with functions f:(Rvec p)->R and then generalize to 
f:(Rvec p)->(Rvec p); results should (hopefully) be consequences of the first case



Definition part_deriv_pt_2 (f:(Rvec p)->R)  (a:(Rvec p)) (i:I_(p))(dp:R):Prop:=
forall eps:R, 0<eps -> exists del, 0<del /\ 
  (forall t, 0< Rabs t < del -> 
Rabs( (f (add_v  a (mult_sv t (base_v i))) - f a)/t - dp) < eps).
*)

(*this should be the limit of a R->R function in a point;
the definition for this limit exists in the Standard Library, but it's different-
we have the condition |t| < del instead of 0<|t|<del, which is not
consistent with usual mathematical definitions *) 

Definition part_deriv_pt_1 (f:(Rvec p)->R)  (a:(Rvec p)) (i:I_(p))(dp:R):Prop:=
limit_R  (fun t => (f (add_v  a (mult_sv t (base_v i))) - f a)/t) R0 dp.

(*
Lemma echiv_dp:
forall (f:(Rvec p)->R)  (a:(Rvec p)) (i:I_(p))(dp:R),
part_deriv_pt_2 (f:(Rvec p)->R)  (a:(Rvec p)) (i:I_(p))(dp:R) <->
part_deriv_pt_1 (f:(Rvec p)->R)  (a:(Rvec p)) (i:I_(p))(dp:R).
Proof.
move =>f a i dp.
split; move =>H;
rewrite /part_deriv_pt_1 /part_deriv_pt_2 /limit_R /limit_gen //= /R_dist //= in H |-*;
move => eps He; elim (H eps He) => alp [Ha Hr]; exists alp; split.
done.
move => x H1.
rewrite (Rminus_0_r ) in H1.
by apply Hr.
done.
move => x H1.
by apply Hr; rewrite Rminus_0_r.
Qed.
*)


Definition dbl_pt_1 (f:(Rvec p)->R) (i:I_(p))(a:(Rvec p)):=
sigT (part_deriv_pt_1 f a i).

Definition dp_1 f i a (pr: dbl_pt_1 f i a):=
projT1 pr.


Lemma part_der_pt_eq:
forall f i a l pr,
dp_1 f i a pr = l <-> part_deriv_pt_1 f a i l.
Proof.
move => f i a l pr.
split; move => H.
have H2 := projT2 pr.
rewrite /dp_1 //= in H.
by rewrite H in H2.
rewrite /dp_1.
have H2 := projT2 pr.
rewrite /part_deriv_pt_1 in H H2.
by apply (uniq_lim_R (fun t : Base R_met => (f (a +^ t *^ base_v i) - f a) / t) 0).
Qed.

Lemma dp_1_pr_nu:
forall f i a pr1 pr2,
dp_1 f i a pr1 = dp_1 f i a pr2.
Proof.
move=> f i a pr1 pr2.
elim pr1 => l1 Hl1; elim pr2=>l2 Hl2; rewrite //=.
rewrite /part_deriv_pt_1 in Hl1 Hl2.
by apply uniq_lim_R with (fun t : Base R_met => (f (a +^ t *^ base_v i) - f a) / t) R0.
Qed.

Notation "\vec_ ( i ) E" :=
  (@vec_of_fun p (fun i  => E)) (at level 25).


Definition modif_v (x:(Rvec p)) (i:I_(p)) (r:R): (Rvec p) :=
\vec_( j  )  if i==j then r else (x j). 

Definition modif (f:(Rvec p)->R)(x:(Rvec p))(i:I_(p))(r:R):R:=
f (modif_v x i r).
(*this gives me a R->R function by modifying the i-th component of a vector fun*)

Lemma modif_id:
forall f x i, modif f x i (x i) = f x.
Proof.
move => f x i.
rewrite /modif /modif_v.
have Heq:  (\vec_(j) if i == j then x i else x j) = x.
rewrite -ext_eq => j; rewrite vxK.
case C: (i==j).
move/eqP :C=>C.
by rewrite C.
done.
by rewrite Heq.
Qed.

Lemma eq_mul_base:
forall x t i, add_v x (mult_sv t (base_v i)) = modif_v x i (x i + t).
Proof.
move => x t i.
rewrite /add_v /base_v /modif_v /mult_sv -ext_eq => j; rewrite !vxK.
case C:(i==j).
move/eqP :C =>C.
by rewrite C ; ring_simplify. 
by  ring_simplify. 
Qed.

Lemma dp_impl_der_pt:
forall f x i l,
part_deriv_pt_1 f x i l <-> derivable_pt_lim (modif f x i) (x i) l.
Proof.
move => f a i l.
split; move => H;
rewrite /part_deriv_pt_1 /limit_R /limit_gen
 /derivable_pt_lim /derivable_pt_abs in H |-*;
move => eps He;
elim (H eps He) => del Hd.
elim Hd => dpos H1; exists (mkposreal del dpos).
move => h Hh Habs.
rewrite modif_id /modif. 
have Ht: 0<Rabs h<del.
split; auto with real.
by apply Rabs_pos_lt.
rewrite /dist //= /R_dist in H1.
rewrite -(Rminus_0_r h) in Ht.
have Hdv':= H1 h Ht.
by rewrite eq_mul_base in Hdv'.
exists (pos del).
split.
apply: cond_pos.
rewrite /dist //= /R_dist.
move => t Ht; rewrite eq_mul_base.
rewrite Rminus_0_r in Ht; elim Ht => Ht1 Ht2.
have A: t <>0.

case (Rcase_abs t).
by apply Rlt_not_eq.
move => H1; elim H1; first by apply Rgt_not_eq.
move => H2.
rewrite H2 Rabs_R0 in Ht1.
elim (Rlt_irrefl R0 Ht1).
have Gd1 := Hd t A Ht2.
by rewrite modif_id /modif in Gd1.
Qed.



Lemma dbl_impl_derb:
forall f x i,
dbl_pt_1 f i x -> derivable_pt (modif f x i) (x i).
Proof.
move => f x i prp.
case prp => x0 H.
rewrite /part_deriv_pt_1 in H.
rewrite /derivable_pt.
rewrite /derivable_pt_abs /derivable_pt_lim.
exists x0 => eps He.
elim (H eps He) => del [Hd Hdv].
exists (mkposreal del Hd) => t Hdif Hrabs.
rewrite modif_id /modif.
have Ht: 0<Rabs t<del.
split; auto with real.
by apply Rabs_pos_lt.
rewrite /dist //= /R_dist in Hdv.
rewrite -(Rminus_0_r t) in Ht.
have Hdv':= Hdv t Ht.
by rewrite eq_mul_base in Hdv'.
Qed.


Lemma dbl_impl_dpb2:
forall f, (forall i x, dbl_pt_1 f i x) ->forall i x, derivable (fun t=> modif f x i t).
Proof.
move=> f H i x t0.
elim ( H i (modif_v x i t0)) => dp Hdp.
exists dp.
move=> eps He.
elim (Hdp eps He) => del [Hdpos Hlim].
exists (mkposreal del Hdpos) => t Hdif Hrabs.
rewrite /modif.
have Ht: 0<Rabs t<del.
split; auto with real.
by apply Rabs_pos_lt.
rewrite /dist //= /R_dist in Hlim.
rewrite -(Rminus_0_r t) in Ht.
have Hdv':= Hlim t Ht.
 rewrite eq_mul_base in Hdv'.
have Heq: (modif_v (modif_v x i t0) i (modif_v x i t0 i + t) = (modif_v x i (t0 + t))).
rewrite /modif_v.
rewrite -ext_eq => j; rewrite !vxK.
case C: (i == j).
have Hi: i==i. 
done.
by rewrite Hi.
done.
by rewrite -Heq.
Qed.

Lemma eq_dp_der:
forall f x i  (prp:dbl_pt_1 f i x),
derive_pt (modif f x i) (x i) (dbl_impl_derb _ _ _ prp) = dp_1 f i x prp.
Proof.    
move => f x i prp.
rewrite derive_pt_eq.
rewrite -dp_impl_der_pt.
rewrite /dp_1.
case prp; rewrite //=.
Qed.



Definition sum_dp_v f a v (pr:forall i x, dbl_pt_1 f i x) :=
\sum_(i) (dp_1 f i a (pr i a)) * v i.



(*define my b's: see megan pages 9 and 32*)

Definition  sum_dp_vi f b v (pr:forall i x, dbl_pt_1 f i x) :=
\sum_(i) (dp_1 f i (b i)  (pr i (b i))) * v i.

Lemma pr_aux:
forall f,
(forall x i,  dbl_pt_1 f i x) -> forall b i, dbl_pt_1 f i (b i).
Proof.
move => f H b i.
exact (H (b i) i).
Qed.




(*
Definition mix (x a :Rvec p) c (i:I_(p)):=
(fun j:I_(p) => match lt_eq_lt_dec (val j) (val i) with
            | inleft w =>match w with
                       |left _ => x j
                       |right _ =>c
                      end
           | inright _ => a j
           end).


Definition modif_v (x:Rvec p) (i:I_(p)) (r:R) :=
fun j:I_(p)=>if i==j then r else (x j). 


Definition modif (f:(Rvec p)->R)(x:Rvec p)(i:I_(p))(r:R):R:=
f (modif_v x i r).



Fixpoint mix (x a :Rvec p) c (i:I_(p)):=
(fun j:I_(p) => match compare_nat i j with
|CompareNatLt _ => a j
| CompareNatGt _ => x j
 | CompareNatEq _=> c
end).




CoInductive compare_nat (m n : nat) : bool -> bool -> bool -> Set :=
  | CompareNatLt : m < n -> compare_nat m n true false false
  | CompareNatGt : m > n -> compare_nat m n false true false
  | CompareNatEq : m = n -> compare_nat m n false false true.


Delimit Scope dnat_scope with Dn.

Definition mix (a x :Rvec p)  c (i:I_(p)):=
(\vec_(j) if (j<i)%Dn then x j else
                         if (j==i) then c else a j).

Definition fun_dif f a x :=
\sum_(i) (f (mix a x (a i) i ) - f (mix a x (x i) i)).

Definition opdp_1:
forall n:nat, (O<n)%nat-> (n.-1<n)%Dn.
Proof.
case; [move=>H|move=> n H].
have Hc: ~((O < O)%nat). by omega.
by elim Hc.
have He: forall n, (n.+1).-1 = n.
case.
omega.
move=> n0; omega.
rewrite (He n).
apply ltnSn.
Qed.



Lemma eq_x:
forall a x i,
 mix a x (x i)  (Ordinal (opdp_1 p Hp)) = x.
Proof.
move=> a x i.
rewrite /mix.
rewrite -ext_eq => j; rewrite !vxK.
have pr:= @ordinal_ltn p j.
case C: ((j < Ordinal (n:=p) (i:=p.-1) (opdp_1 p Hp))%Dn);[done|].
case 

Lemma eq_sum_fun:
forall f a x,
\sum_(i) (f (mix a x (a i) i ) - f (mix a x (x i) i)) = f a - f x.
Proof.
move=> f a x.
unlock reducebig.
elim (index_enum I_(p)) => //=.


(*this gives me a R->R function*)

Fixpoint mod_vec_rec (x a :Rvec p)(l:seq I_(p)) {struct l}:Rvec p:=
match l with 
|seq0 => x
|Adds i l' => modif_v (mod_vec_rec x a l') i (a i)
end.




Definition dfi_fun (f:(Rvec p)->R) (x a:Rvec p) (l:seq I_(p)):R:=
match l with
|seq0 => 0
|Adds i l' =>f (mod_vec_rec x a l') - f (mod_vec_rec x a (Adds i l'))
end.

Definition dif_fun_tot f x a :=
dfi_fun f x a (index_enum I_(p)).

Delimit Scope dnat_scope with Dn.

Definition mk_seq_before (i:I_(p)):seq I_(p):=
maps (@ord_of_natsig p) (subfilter (fun m => (m < p)%nat) 
(iota O i)).

(*the current index included*)

Definition mk_seq_after (i:I_(p)): seq I_(p):=
maps (@ord_of_natsig p) (subfilter (fun m => (i<m)%Dn && (m < p)%Dn) 
(iota O (p-(S i))%nat)).
*)


(*

Definition mix  (x a:Rvec p) c (i:I_(p)):=
\vec_(j<-p) match lt_eq_lt_dec ( j) ( i) with
            | inleft w =>match w with
                       |left _ => x j
                       |right _ =>c
                      end
           | inright _ => a j
           end.

Lemma lt_i: forall i:I_(p), (O<i)%Dn -> ((i.-1) < p)%Dn.
Proof.
case.
rewrite //=.
move=> i H0 Hi.
apply ltn_trans with i; [|done].
rewrite -{2}(ltnSpred Hi).
apply ltnSn.
Qed.


Lemma eq_dif1 : forall x a i:I_(p),
i = ord_of_natsig O Hp ->
mix x a (a i) i = a.

Definition dif_fun2  f x a i:=
f (mix  x a (x i) i) - f (mix  x a (a i) i).

Definition sum_fun  f x a :=
\sum_(i) dif_fun2 f x a i.


Lemma eq_sum_fun:
forall (f:Rvec p->R) x a, sum_fun f x a = 0. (*mock th; should have fx - fa*)
Proof.
move =>  f x a.
rewrite /sum_fun /dif_fun2.
unlock reducebig.
elim (index_enum I_(p)); rewrite //=.
move => j s IH .
elim s ; rewrite //=.


move : (I_not_void p Hp).
rewrite /index_enum //= /ord_enum //=. /iota /subfilter //=.

move : (I_not_void p Hp).
elim (index_enum I_(p)); rewrite //=.
move => j s IH _.


have Hmk:= (big_mkord (fun _ => true) (fun i => dif_fun2 f x a i)).
rewrite //=. -big_mkord.
rewrite /sum_fun /dif_fun2.


Definition dif_fun_index dfi_fun 
   (f:(Rvec p)->R) (x a:Rvec p) (l:seq I_(p)) :R:=


Definition sum_fun f x a r :=
\sum_(<-r |(fun _ => true)) (dfi_fun f x a r. 

Fixpoint sum_fun  (f:(I->R)->R) (x a:I->R) (l:seq I):R:=
match l with
|seq0 => 0
|Adds i l' => sum_fun f x a l' + dfi_fun f x a (Adds i l')
end.

Lemma rel_dif_fun_step:
forall f x a l,l!=seq0-> f x - f (mod_vec_rec x a l) = sum_fun f x a l.
Proof.
move => f x a.
move => l ;elim l.
rewrite //=.
move => x0 s IHeq IHdif.
case C: (s != seq0).
have H:= IHeq C.
simpl sum_fun.
rewrite -H.

simpl mod_vec_rec.
ring.
move/eqP :C=>C.
rewrite C.
rewrite //=.
ring.
Qed.

*)

Delimit Scope dnat_scope with Dn.

Definition mix (a x :Rvec p)  c (i:I_(p)):=
(\vec_(j) if (j<i)%Dn then x j else
                         if (j==i) then c else a j).

Definition fun_dif f a x :=
\sum_(i) (f (mix a x (a i) i ) - f (mix a x (x i) i)).

Definition g (a b :Rvec p)  i: Rvec p:=
(\vec_(j) if (j<i)%Dn then b j else a j).


Definition hf f a b i:= (f (g a b i) - f (g a b (S i)%Dn)).

Definition f1 f a b i:=
if (i == O)%Dn then (f a - f b) else (f (g a b i) - f (g a b (i + (S O))%Dn)).

Lemma modif_to_p: forall a b,
g a b p = b.
Proof.
move => a b; rewrite /g -ext_eq=> j; rewrite !vxK.
have H:(j<p)%Dn.
apply ordinal_ltn.
by rewrite H.
Qed.

Lemma fun_one_var:
forall a b (i:I_(p)),
g a b (S i) = modif_v (g a b i) i (b i).
Proof.
move=> a b i.
rewrite /modif_v -ext_eq => j; rewrite !vxK.
case C1: (j < i.+1)%Dn; move/leP:C1=>C1.
case C2: (i==j)%Dn; move/eqP:C2=>C2;[by rewrite C2|].
have H1: ~((i:nat) = (j:nat)).
move=>H1.
have H2: i = j.
have H := @ordinal_inj p.
apply (H i j H1).
by elim C2.
have H3: (j<i)%nat.
omega.
have H4: (j<i)%Dn.
by apply/leP.
by rewrite H4.
case C2: (i == j).
elim C1.
by move/eqP:C2=>C2; rewrite C2.
case C3: ((j<i)%Dn).
elim C1.
move/leP:C3=>C3; omega.
done.
Qed.


Lemma sum_h:
forall  f a b i,
\sum_(j< (S i)) hf f a b j = (f a - f (g a b (S i)))%R.
Proof.
move=> f a b i.
induction i; rewrite //=.
rewrite /hf.
rewrite (big_set1 ord0) //=.
congr (_ - _);
f_equal; rewrite /g;
rewrite -ext_eq => j; rewrite !vxK;
by case Hb: ( (j < O)%Dn ).
move=> x; rewrite //=.
symmetry; apply/eqP. 
case: x =>// i Hi.
rewrite / ord0.
apply/ord_eqP=>//=; apply/eqP.
move/leP: Hi => Hi; omega.
by rewrite big_ord_recr //= IHi  /hf; simp_R.
Qed.

Lemma write_to_sum:
forall  f a b, 
\sum_(j< p) hf f a b j = f a - f b.
Proof.
move=> f a b .
rewrite -{2}(modif_to_p a b).
have Hp1: (p:nat) = S (p.-1).
have H := Hp.
omega.
rewrite Hp1.
apply sum_h.
Qed.

Lemma write_to_sum2:
forall f a b,
\sum_(j< p)  (f (g a b j) - f (modif_v (g a b j) j (b j))) = f a - f b.
Proof.
move=> f a b.
transitivity (\sum_(j< p) hf f a b j).
apply: eq_bigr => j  _; by rewrite -fun_one_var /hf.
apply write_to_sum.
Qed.

Lemma eq_ga:
forall a b (i:I_(p)), g a b i i = a i.
Proof.
move=> a b i; rewrite /g !vxK.
have H: (i<i)%Dn=false.
apply/leP; omega.
by rewrite H.
Qed.

Lemma eq_gb:
forall a b (i:I_(p)), modif_v (g a b i) i (b i) i = b i.
Proof.
move=> a b i; rewrite /modif_v !vxK.
have H: i==i.
done.
by rewrite H.
Qed.



Lemma pag9:
forall f a v (pr: forall i x, dbl_pt_1 f i x), 
(forall i, @cont_Rp_R  p (fun x => dp_1 f i x (pr i x)) a) ->
exists c, (forall i, dist_Rp (c i) a <=  dist_Rp v a)/\
                 (f v - f a = sum_dp_vi f c (dif_v v a) pr).
Proof.
move=> f b a pr Hc.
have Hs:= write_to_sum2 f a b.
rewrite -Hs /sum_dp_vi.
have H2:forall (i:I_(p)), exists ck, Rabs (ck - b i)
   <= Rabs ( a i - b i)/\ (f (g a b i) - f (modif_v (g a b i) i (b i)))=
derive_pt (fun t : R => modif f (g a b i) i t) ck
  (dbl_impl_dpb2 f pr i (g a b i) ck) *(a i - b i).
(*
derive_pt (modif f (modif_v (g a b i) i c) i) ((modif_v (g a b i) i c) i)  
(dbl_impl_derb f (modif_v (g a b i) i c) i  (pr i (modif_v (g a b i ) i c  )) )* (a -^ b) i.
*)
move=> i.
rewrite -(modif_id f (g a b i) i) eq_ga.
rewrite -/(modif f (g a b i) i (b i)).
elim (Rlt_le_dec (b i) (a i)) => Hdec.
elim (MVT_cor1 (fun t=>modif f (g a b i) i t) (b i) (a i) 
  (dbl_impl_dpb2 f pr i (g a b i)) Hdec) =>ck [Heq Hk].
exists ck; split; elim Hk => Hk1 Hk2.
rewrite !Rabs_pos_eq; simp_R; fourier.
by rewrite Heq.
elim Hdec => Hd1.
elim (MVT_cor1 (fun t=>modif f (g a b i) i t) (a i) (b i) 
  (dbl_impl_dpb2 f pr i (g a b i)) Hd1) =>ck [Heq Hk].
exists ck; split; elim Hk => Hk1 Hk2.
rewrite Rabs_minus_sym (Rabs_minus_sym (a i) (b i)) !Rabs_pos_eq; simp_R; fourier.
rewrite -Ropp_minus_distr Heq.
by ring_simplify .
exists (a i); split; first by right.
rewrite Hd1.
by ring_simplify.

case (choice _ H2) => ch Hch.

(* (fun (i:I_(p)) ck =>Rabs (ck - b i) <= Rabs (a i - b i)
   /\ f (g a b i) - f (modif_v (g a b i) i (b i)) =
       derive_pt (fun t : R => modif f (g a b i) i t) ck
         (dbl_impl_dpb2 f pr i (g a b i) ck) * (a i - b i)) H2)=> ch Hch.
*)
exists (fun i:I_(p) => modif_v (g a b i) i (ch i)).
split.
move=> i.
elim (Hch i) =>[H1 _].
rewrite /dist_Rp.
elim (norm_rew Hp ((modif_v (g a b i) i (ch i) -^ b))) => k Hk.
rewrite Hk /modif_v /g.
case C: (i == k); rewrite  {1}/dif_v !vxK C.
move/eqP:C=>C.
rewrite -C .
apply Rle_trans with (Rabs (a i - b i)); [done|].
replace (a i - b i) with ((a -^ b) i);[|by rewrite vxK ]; apply norm_max.
case C2: (k < i)%Dn.
rewrite /Rminus Rplus_opp_r Rabs_R0; apply (norm_pos).
replace (a k - b k) with ((a -^ b) k);[|by rewrite vxK ]; apply norm_max.
apply: eq_bigr=> i _; elim (Hch i) => [ _ Heq]; rewrite Heq vxK.
have Heq2: derive_pt (fun t : R => modif f (g a b i) i t) (ch i)
  (dbl_impl_dpb2 f pr i (g a b i) (ch i)) = 
dp_1 f i (modif_v (g a b i) i (ch i)) (pr i (modif_v (g a b i) i (ch i))).
rewrite -eq_dp_der.
have H0: modif_v (g a b i) i (ch i) i  = ch i.
rewrite /modif_v !vxK.
have H01: i==i;[by done|]; by rewrite H01.
rewrite -{1 2}H0.
apply fun_eq_der_eq => x.
rewrite /modif {1 2}/modif_v; f_equal.
rewrite -ext_eq=> j; rewrite !vxK.
by case C: (i==j).
by rewrite Heq2.
Qed. 


(*

Lemma lt_i: forall i:I_(p), (O<i)%Dn -> ((i.-1) < p)%Dn.
Proof.
case.
rewrite //=.
move=> i H0 Hi.
apply ltn_trans with i; [|done].
rewrite -{2}(ltnSpred Hi).
apply ltnSn.
Qed.

Definition fun_dif1 f a b (i:I_(p)) :=
match (i<O)%Dn as H with
|true=> (f (g a b i) - f (g a b ( Ordinal (lt_i i H))))
|false => (f a - f b)
end.

if ((i:nat) < O)%Dn then (f (g a b i) - f (g a b (i -1)))

(f a - f b) else (f (g a b i) - f (g a b (i -1))).

\sum_(i) (f (mix1 a x  i ) - f ( modif_v (mix1 a x i)  i (a i) )).


Definition myfilter  i (l:seq I_(p)) := filter (fun m:I_(p)=> (m < i)%Dn) l.
Check myfilter.

Definition  my_tot_filter := myfilter p (index_enum I_(p)).
Lemma myfil_index:
my_tot_filter = index_enum I_(p).
Proof.
rewrite /my_tot_filter /myfilter.
have Hm:= mem_filter (fun m : I_(p) => (m < p)%Dn) (index_enum I_(p)).
have Hin: forall x, index_enum I_(p) x = true.
move=> x.
rewrite /index_enum -(filter_setA (enum I_(p))) filter_enum /setA //=.

have Heq: 
setI (fun m : I_(p) => (m < p)%Dn) (index_enum I_(p)) =1 (index_enum I_(p)).
rewrite /setI //=.
move=> x; rewrite //= Hin andbT.
apply ordinal_ltn .
elim (index_enum I_(p)) => //=.
move=> x s IH.
have Heq1: (x < p)%Dn=true.
apply ordinal_ltn.
rewrite Heq1.
by congr Adds.
Qed.

rewrite  -(filter_setA (index_enum I_(p))) /setA //=.
have Heq2:= (filter_setA (index_enum I_(p))).
have H:= enum_setA.
 /enum //= /ord_enum //=.


Check myfilter.


  maps ord_of_natsig (subfilter (fun m => m < n) (iota 0 n)).
 
                         if (j==i) then c else a j).




Lemma pag9:
forall f a v (pr: forall i x, dbl_pt_1 f i x), 
(forall i, cont_Rp_R Hp (fun x => dp_1 f i x (pr i x)) a) ->
exists b, (forall i, 0<dist_Rp (b i) a <=  dist_Rp v a)/\
                 (f v - f a = sum_dp_vi f b (dif_v v a) pr).
Admitted.

*)

Lemma equiv_gat:
forall f a (pr: forall i x, dbl_pt_1 f i x), 
(forall i, cont_Rp_R  (fun x=> dp_1 f i x (pr i x)) a) ->
limit_Rp_R  (fun x => ((f x - f a) - (sum_dp_v f a (dif_v x a) (pr )))/dist_Rp x a) a 0. 
Proof.
move => f a pr Hcont.
red => eps Heps.
rewrite /cont_Rp_R /limit_Rp_R /cont_gen //= in Hcont.
have Hc1: forall eps, eps >0 -> forall i, exists alp, alp > 0 /\
            (forall v ,
              dist_Rp v a < alp ->  Rabs (dp_1 f i v (pr i v) - dp_1 f i a (pr i a)) < eps).
move=> e He i; exact (Hcont i e He).
have Hep: eps/INR p >0.
have Hp1: 0<INR p.
by apply lt_INR_0; exact Hp.
rewrite /Rdiv.
apply Rmult_gt_0_compat; [done|].
rewrite /Rgt.
by apply Rinv_0_lt_compat.
elim (choice (fun i alp => alp > 0 /\
          (forall v ,
           dist_Rp v a < alp -> 
 Rabs (dp_1 f i v (pr i v) - dp_1 f i a (pr i a))  < eps/INR p)) (Hc1 
  (eps/INR p) Hep))=> cf Hrel.
exists (min_del cf) .
split.
apply: (min_ge0 Hp).
move => j; elim (Hrel j) => Hinq Hrest; apply: Hinq.
move =>v Hdist.
elim (pag9 f a v pr Hcont) => b [Hipb Heq].
rewrite /dist //= /R_dist Heq Rminus_0_r .
rewrite /sum_dp_vi /sum_dp_v.
have Heq1: (\sum_(i) dp_1 f i (b i) (pr i (b i)) * (v -^ a) i -
    \sum_(i) dp_1 f i a (pr i a) * (v -^ a) i)%Ri = 
(\sum_(i) dp_1 f i (b i) (pr i (b i)) * (v -^ a) i -
    \sum_(i) dp_1 f i a (pr i a) * (v -^ a) i).
by simp_R.
rewrite -Heq1.
rewrite -sum_split_sub; simp_R.

 have Heq2:
((\sum_(i) (dp_1 f i (b i) (pr i (b i)) * (v -^ a) i -
              dp_1 f i a (pr i a) * (v -^ a) i))%Ri / dist_Rp v a)= 
((\sum_(i) ((dp_1 f i (b i) (pr i (b i)) -
              dp_1 f i a (pr i a) ) * (v -^ a) i)) */ dist_Rp v a)%Ri.
rewrite /Rdiv.
congr (_*_).
by apply eq_bigr => i _; simp_R.
rewrite Heq2.
have Haux: 0</dist_Rp v a.
elim Hdist =>H1 H2;by apply Rinv_0_lt_compat.
rewrite big_distrl /=.

apply Rle_lt_trans with (
\sum_(i) Rabs ((dp_1 f i (b i) (pr i (b i) ) - dp_1 f i a (pr i a)) * (v -^ a) i /
   dist_Rp v a)).
apply: (abs_sum_le_f ).
apply: (ineq_sum_el Hp).
rewrite /Rle; left; apply: Heps.
move => x.
rewrite /dist_Rp.
elim (norm_rew Hp (dif_v v a)) => k Heqn.
rewrite {1}/Rdiv Rmult_assoc  Rabs_mult.
apply Rle_lt_trans with (Rabs (dp_1 f x (b x) (pr x (b x)) - dp_1 f x a (pr x a)) *1).
apply Rmult_le_compat_l;[apply Rabs_pos|].
rewrite Heqn Rabs_mult  Rabs_Rinv.
rewrite  (Rabs_Rabsolu ((v -^ a) k)) -Heqn.
apply: el_div_norm_leq.
rewrite -/(dist_Rp v a).
by elim Hdist.
rewrite -Heqn -/(dist_Rp v a).
by apply Rgt_not_eq; elim Hdist.
rewrite Rmult_1_r .
elim (Hrel x) => [H1 H2].
apply (H2 (b x)).
apply Rle_lt_trans with (dist_Rp v a) ; first by elim (Hipb x).
apply Rlt_le_trans with (min_del cf);[by elim Hdist|by apply min_min].
Qed.


Require Import Classical_Prop.
Require Import Classical_Pred_Type.

Lemma interm:
forall v,
v = (vect0 p) \/ v <> (vect0 p).
Proof.
move =>v.
rewrite -ext_eq.
apply classic.
Qed.

Lemma lim_der:
forall f (a:Rvec p) v pr,
(forall i, cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr i x)) a) ->

derivable_pt_lim (fun t : R => f (add_v a (mult_sv t v))) 0 (sum_dp_v f a v pr).
Proof.
move => f a v pr Hc.
elim (interm v) => H.
rewrite H.
have Heq: (sum_dp_v f a (vect0 p) pr) = 0.
rewrite /sum_dp_v .
have H1: \sum_(i) dp_1 f i a (pr i a) * (vect0 p) i  = \sum_(i<p) 0.
by apply: eq_bigr => i _; rewrite vxK; ring_simplify.
by rewrite H1 big1_eq.
rewrite Heq.
apply lim_der_eq with (fun t:R => f a).
move => t.
replace (add_v a (mult_sv t (vect0 p))) with ( a);[done |].
rewrite -ext_eq /vect0 /mult_sv /add_v=>i ; rewrite //= !vxK .
by rewrite Rmult_0_r Rplus_0_r.
rewrite /derivable_pt_lim in |- *.
  intros; exists (mkposreal 1 Rlt_0_1); intros; unfold Rminus in |- *;
    rewrite Rplus_opp_r; unfold Rdiv in |- *; rewrite Rmult_0_l;
      rewrite Rplus_opp_r; rewrite Rabs_R0; assumption.
rewrite /derivable_pt_lim => eps He. 
replace (mult_sv 0 v) with (vect0 p).
replace (add_v a (vect0 p)) with a.
have Heqf: forall t,t<>0 -> (f (add_v a (mult_sv (0 + t) v)) - f a) / t = 
((sum_dp_v f a (mult_sv t v) pr) + (norm (mult_sv t v))*
((f (add_v a (mult_sv (0 + t) v)) - f a)  - 
  (sum_dp_v f a (mult_sv t v) pr))/(norm (mult_sv t v)))/t.
move => t Ht.
field.
split; last by done.
rewrite -ext_eq in H.
rewrite (norm0 Hp) -ext_eq /eqfun.
apply ex_not_not_all.
have H3: exists k, v k <> (vect0 p) k.

by apply  not_all_ex_not .
elim H3 => k Hdif.
exists k.
rewrite /vect0 /mult_sv !vxK in Hdif |-*. 
apply Rmult_integral_contrapositive.
by split.
have Hgat:

limit_Rp_R (fun x => ((f x - f a) - (sum_dp_v f a (dif_v x a) (pr )))/dist_Rp x a) a 0. 
by apply equiv_gat.
have Hnorm: 0<norm v.
have H1:= norm_pos v.
elim H1; first by done.
move => H2.
rewrite -(norm0 Hp) /not  in H.
have H3: norm v = 0 ; by rewrite -H2.
have He1:0< eps/(norm v). 
rewrite /Rdiv.
apply Rmult_lt_0_compat; first by done .
by apply Rinv_0_lt_compat.
elim (Hgat (eps/norm v) He1) => del Hd.
elim Hd => Hd1 Hder.
have Hdn: 0 < del* /norm v.
 apply Rmult_lt_0_compat; [done| by apply Rinv_0_lt_compat].
exists (mkposreal (del*/norm v) Hdn)
=> h Hh1 Hh2.
have Hav: 0 < dist_Rp (a +^ (0+h) *^ v) a < del.
rewrite /dist_Rp.
have Heq1: (a +^ (0 + h) *^ v) -^ a = h *^ v.
rewrite -ext_eq => i; rewrite !vxK .
by simp_R; ring_simplify.

rewrite Heq1 (norm_hom_pos Hp).
split.
apply Rmult_lt_0_compat;[by apply Rabs_pos_lt|done].
apply (Rmult_lt_reg_l (/norm v)).
by apply Rinv_0_lt_compat.
rewrite //= Rmult_comm Rmult_assoc Rinv_r.
rewrite  /1 //= Rmult_1_r Rmult_comm.
apply Hh2.
apply Rgt_not_eq; apply Hnorm.
rewrite Rplus_0_l in Hav |-*.
have Hs: sum_dp_v f a v pr = sum_dp_v f a (a +^ h*^ v -^ a) pr /h.
rewrite /sum_dp_v /Rdiv.
have Heq3: ((\sum_(i) (dp_1 f i a (pr i a) * ((a +^ h *^ v) -^ a) i)) * / h)=
((\sum_(i) (dp_1 f i a (pr i a) * ((a +^ h *^ v) -^ a) i)) * / h)%Ri by simp_R.
rewrite Heq3.
rewrite big_distrl //=.
by apply: eq_bigr => i _; rewrite !vxK; simp_R; field.
rewrite Hs.
have H3: ((f (a +^ h *^ v) - f a) / h - sum_dp_v f a ((a +^ h *^ v) -^ a) pr / h) = 
((f (a +^ h *^ v) - f a)  - sum_dp_v f a ((a +^ h *^ v) -^ a) pr )/ h
by field.
rewrite H3.
have Hj:= Hder (a +^ h *^ v) Hav.
rewrite /dist //= /R_dist Rminus_0_r in Hj.
rewrite /Rdiv !Rabs_mult in Hj |-*.
apply: (Rmult_lt_reg_l (/norm v)).
by apply Rinv_0_lt_compat.
rewrite Rmult_comm Rmult_assoc Rabs_Rinv.
rewrite -Rinv_mult_distr.
have Hnv: Rabs h * norm v = Rabs (dist_Rp (a +^ h *^ v) a).
rewrite -(norm_hom_pos Hp v h) /dist_Rp.
have Heq1: ((a +^  h *^ v) -^ a)%R = (h *^ v)%R.
rewrite -ext_eq => i; rewrite !vxK; simp_R; field .

 rewrite Heq1 Rabs_pos_eq ; [done| apply norm_pos; exact Hp].
rewrite Hnv -Rabs_Rinv.
replace (/norm v * eps)%R with (eps * /norm v)%R.

apply Hj.
apply Rmult_comm.
apply Rgt_not_eq; by elim Hav.
apply Rgt_not_eq; by apply: Rabs_pos_lt.
by apply Rgt_not_eq.
done.
by rewrite  -ext_eq => i; rewrite !vxK; simp_R; rewrite Rplus_0_r.
by rewrite /mult_sv /vect0 -ext_eq => i; rewrite !vxK Rmult_0_l.
Qed.



Lemma der_pt_sum:
forall f a v pr,
(forall i, cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr i x)) a) ->
derivable_pt (fun t : R => f (add_v a (mult_sv t v))) 0.
Proof.
move => f a v pr Hcont.
rewrite /derivable_pt /derivable_pt_abs.
exists (sum_dp_v f a v pr).
by apply lim_der.
Qed.


Lemma equiv_lim:
forall f a v pr (Hcont: (forall i, cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr i x)) a)),
derive_pt  (fun t =>f (add_v a (mult_sv t v))) 0 (der_pt_sum f a  v pr Hcont) = 
sum_dp_v f a v pr.
Proof.
move => f a v pr Hcont.
apply derive_pt_eq_0.
by apply lim_der.
Qed.

Lemma equiv_lim2:
forall f a v pr (Hcont: (forall  i a, cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr i x)) a)),
derive_pt  (fun t =>f (add_v a (mult_sv t v))) 0 (der_pt_sum f a  v pr (fun i =>Hcont i a)) = 
sum_dp_v f a v pr.
Proof.
move => f a v pr Hcont.
apply derive_pt_eq_0.
by apply lim_der.
Qed.

Lemma lim_der_t:
forall f (a:Rvec p) v pr t,
(forall i v, cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr i x)) v) ->
derivable_pt_lim (fun h : R => f (add_v a (mult_sv h v))) t 
(sum_dp_v f (a +^ t*^ v)v pr).
Proof.
move => f a v pr t Hc.
elim (interm v) => H.
rewrite H.
have Heq: (sum_dp_v f (a+^ t *^ vect0 p) (vect0 p) pr) = 0.
rewrite /sum_dp_v .
have H1: \sum_(i) dp_1 f i (a+^ t *^ vect0 p) 
   (pr i (a+^ t *^ vect0 p)) * (vect0 p) i  = \sum_(i<p) 0.
by apply: eq_bigr => i _; rewrite vxK; ring_simplify.
by rewrite H1 big1_eq.
rewrite Heq.
apply lim_der_eq with (fun t:R => f a).
move => h.
replace (add_v a (mult_sv h (vect0 p))) with ( a);[done |].
rewrite -ext_eq /vect0 /mult_sv /add_v=>i ; rewrite //= !vxK .
by rewrite Rmult_0_r Rplus_0_r.
rewrite /derivable_pt_lim in |- *.
  intros; exists (mkposreal 1 Rlt_0_1); intros; unfold Rminus in |- *;
    rewrite Rplus_opp_r; unfold Rdiv in |- *; rewrite Rmult_0_l;
      rewrite Rplus_opp_r; rewrite Rabs_R0; assumption.
rewrite /derivable_pt_lim => eps He.

have Heqf: forall h,h<>0 -> 
(f (add_v a (mult_sv (t+h) v)) - f (a +^ t *^ v)) / h=
 
((sum_dp_v f (a+^ (t + h) *^ v) (mult_sv h v) pr) + (norm (mult_sv h v))*
((f (add_v a (mult_sv (t +h) v)) - f (a+^ t *^ v))  - 
(sum_dp_v f (a +^ (t+h)*^ v) (mult_sv h v) pr))/(norm (mult_sv h v)))/h.
move => h Hh.
field.
split; last by done.
rewrite -ext_eq in H.
rewrite (norm0 Hp) -ext_eq /eqfun.
apply ex_not_not_all.
have H3: exists k, v k <> (vect0 p) k.

by apply  not_all_ex_not .
elim H3 => k Hdif.
exists k.
rewrite /vect0 /mult_sv !vxK in Hdif |-*. 
apply Rmult_integral_contrapositive.
by split.

have Hgat:
limit_Rp_R  (fun x => ((f x - f (a+^ t*^v) - 
  (sum_dp_v f (a+^t*^v) (dif_v x (a+^t*^v)) pr)))
/dist_Rp x (a+^t*^v)) (a+^t*^v) 0. 
by apply equiv_gat.
have Hnorm: 0<norm v.
have H1:= norm_pos v.
elim H1; first by done.
move => H2.
rewrite -(norm0 Hp) /not  in H.
have H3: norm v = 0 ; by rewrite -H2.
have He1:0< eps/(norm v). 
rewrite /Rdiv.
apply Rmult_lt_0_compat; first by done .
by apply Rinv_0_lt_compat.
elim (Hgat (eps/norm v) He1) => del Hd.
elim Hd => Hd1 Hder.
have Hdn: 0 < del* /norm v.
 apply Rmult_lt_0_compat; [done| by apply Rinv_0_lt_compat].
exists (mkposreal (del*/norm v) Hdn)
=> h Hh1 Hh2.
have Heq1: (a +^ (t+h) *^ v) -^ (a+^t*^v) = h *^ v.
rewrite -ext_eq => i; rewrite !vxK .
by simp_R; ring_simplify.
have Hav: 0 < dist_Rp (a +^ (t+h) *^ v) (a+^t*^v) < del.
rewrite /dist_Rp.
rewrite Heq1 (norm_hom_pos Hp).
split.
apply Rmult_lt_0_compat;[by apply Rabs_pos_lt|done].
apply (Rmult_lt_reg_l (/norm v)).
by apply Rinv_0_lt_compat.
rewrite //= Rmult_comm Rmult_assoc Rinv_r.
rewrite  /1 //= Rmult_1_r Rmult_comm.
apply Hh2.
apply Rgt_not_eq; apply Hnorm.
have Hs: sum_dp_v f (a+^t*^v) v pr =
 sum_dp_v f (a+^t*^v) (a +^ (t+h)*^ v -^ (a+^t*^v)) pr /h.
rewrite /sum_dp_v /Rdiv.
have Heq3: (\sum_(i) dp_1 f i (a +^ t *^ v) (pr i (a +^ t *^ v)) * (h *^ v) i) * / h = 
((\sum_(i) dp_1 f i (a +^ t *^ v) (pr i (a +^ t *^ v)) * (h *^ v) i) * / h)%Ri by simp_R.
rewrite Heq1 Heq3 big_distrl //=.
by apply: eq_bigr => i _; rewrite !vxK; simp_R; field.
rewrite Hs Heq1.
have H3: ((f (a +^(t+ h) *^ v) - 
  f (a+^t*^v)) / h - sum_dp_v f (a +^ t *^ v) (h*^v) pr / h) = 
((f (a +^(t+ h) *^ v) - f (a+^t*^v))  - sum_dp_v f (a+^t*^v) (h *^ v)  pr )/ h
by field.
rewrite H3.
rewrite /dist //= in Hder.
have Hj:= Hder (a +^ (t+ h) *^ v) Hav.
rewrite /dist //= /R_dist Rminus_0_r in Hj.
rewrite /Rdiv !Rabs_mult in Hj |-*.
apply: (Rmult_lt_reg_l (/norm v)).
by apply Rinv_0_lt_compat.
rewrite Rmult_comm Rmult_assoc Rabs_Rinv.
rewrite -Rinv_mult_distr.
have Hnv: Rabs h * norm v = Rabs (dist_Rp (a +^(t+ h) *^ v) (a+^t*^v)).
rewrite -(norm_hom_pos Hp v h) /dist_Rp.
 rewrite Heq1 Rabs_pos_eq ; [done|by apply norm_pos; exact Hp].
rewrite Hnv -Rabs_Rinv.
replace (/norm v * eps)%R with (eps * /norm v)%R.
rewrite Heq1 in Hj.
apply Hj.
apply Rmult_comm.
apply Rgt_not_eq; by elim Hav.
apply Rgt_not_eq; by apply: Rabs_pos_lt.
by apply Rgt_not_eq.
done.
Qed.



Lemma der_pt_sum_t:
forall f a v pr t,
(forall i v, cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr i x)) v) ->
derivable_pt (fun t : R => f (add_v a (mult_sv t v))) t.
Proof.
move => f a v pr t Hcont.
rewrite /derivable_pt /derivable_pt_abs.
exists (sum_dp_v f (a+^t*^v) v pr).
by apply lim_der_t.
Qed.


Lemma equiv_lim_t:
forall f a v pr t (Hcont: (forall i (v:Rvec p), 
   cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr i x)) v)),
derive_pt  (fun t =>f (add_v a (mult_sv t v))) t (der_pt_sum_t f a  v pr t Hcont) = 
sum_dp_v f (a+^t*^v) v pr.
Proof.
move => f a v pr t Hcont.
apply derive_pt_eq_0.
by apply lim_der_t.
Qed.


Lemma dp_mul_const_1:
forall f a i k dp ,
part_deriv_pt_1 f a i dp -> part_deriv_pt_1 (fun v => f v*k) a i (dp*k).
Proof.
move=> f a i k dp H.
rewrite Rmult_com.
have Hf: forall v, f v*k = k*f v.
move=> v; by rewrite Rmult_com.
(*have Hl: part_deriv_pt_1 (fun v : Rvec p => k*f v ) a i (k * dp).*)
 red; red.
apply echiv_lim_f1 with (X':= R_met)
(f:= fun t: Base R_met => 
  k* ((f (a+^ t *^ base_v i) - f a) / t)).
by move=> t; rewrite /Rdiv; ring_simplify.
apply: limit_R_multc.
apply: H.
Qed.

Lemma dp_mul_const_2:
forall f a i k ,
dbl_pt_1 f a i -> dbl_pt_1 (fun v => f v*k) a i.
Proof.
move=> f a i k H.
elim H => dp Hdp.
exists (dp*k).
by apply dp_mul_const_1.
Qed.

Lemma dp_mul_const:
forall f a i pr k,
(dp_1 f a i pr)*k = dp_1 (fun v => f v*k) a i (dp_mul_const_2 _ _ _ _ pr).
Proof.
move=> f i a pr k.
rewrite /dp_1.
have Hpr1:= projT2 pr.
have Hq:= dp_mul_const_1 f a i k (projT1 pr) Hpr1.
case (dp_mul_const_2 f i a k pr) => p2 Hp2; rewrite /=.
red in Hq.
by apply uniq_lim_R with 
(f:= (fun t : Base R_met => (f (a +^ t *^ base_v i) * k - f a * k) / t))
 (x:=R0).
Qed.


(*define derivatives for functions f: (Rvec p)-> (Rvec p)*)

Definition part_deriv_pt (f:(Rvec p) -> (Rvec p)) (a:(Rvec p)) (i:I_(p)) (dp:(Rvec p)):Prop:=
limit_R_Rp  (fun t => /t *^ ((f (a +^ t *^ (base_v i))) -^ (f a))) 0 dp.
(*

forall eps:R, 0<eps -> exists del, 0<del /\ 
  (forall t, 0< Rabs t < del -> 
norm ( /t *^ ((f (a +^ t *^ (base_v i))) -^ (f a)) -^ dp) < eps).
*) 

Definition dbl_pt (f:(Rvec p)->(Rvec p)) (i:I_(p))(a:(Rvec p)):=
sigT (part_deriv_pt f a i).

Definition der_p f i a (pr: dbl_pt f i a):=
projT1 pr.


Lemma echiv_der_p: forall f a i dp,
part_deriv_pt f a i dp <->
forall j, part_deriv_pt_1 (fun v => (f v) j) a i (dp j).  
Proof.
move => f a i dp.
rewrite /part_deriv_pt /part_deriv_pt_1.
rewrite echiv_lim_R_Rp.
split; move => H j; have H1:= H j.
rewrite /limit_R .
rewrite (echiv_lim_f R_met R_met (fun t => (f (a +^ t *^ base_v i) j - f a j) / t)
( fun v : Base R_met => (/ v *^ (f (a +^ v *^ base_v i) -^ f a)) j ) ).
by move => t; rewrite !vxK /Rdiv; ring_simplify.
by rewrite /limit_R in H1.
rewrite /limit_R .
rewrite (echiv_lim_f R_met R_met 
( fun v : Base R_met => (/ v *^ (f (a +^ v *^ base_v i) -^ f a)) j )
(fun t => (f (a +^ t *^ base_v i) j - f a j) / t) ).
by move => t; rewrite !vxK /Rdiv; ring_simplify.
by rewrite /limit_R in H1.
Qed.

Lemma echiv_der_p1:
forall (f:Rvec p -> Rvec p) i a,
(forall j, dbl_pt_1 (fun v : Rvec p => f v j) i a) ->
dbl_pt f i a.
Proof.
move => f i a H.
rewrite /dbl_pt_1 in H.
rewrite /dbl_pt .
rewrite /part_deriv_pt_1 in H.
have X: ({g : I_(p)->R & forall j:I_(p), limit_R (fun t : Base R_met =>
                                                            (f(a+^t*^ base_v i) j - f a j)/t) 0 (g j)}).  
exists (fun j=> let (dp, _) := H j in dp).
intros j; case (H j); auto.
elim X => g1 Hg.
exists (\vec_(j) g1 j).
rewrite echiv_der_p => j; rewrite vxK /part_deriv_pt_1; apply Hg.
Qed. 

Lemma echiv_der_p2:
forall (f:Rvec p -> Rvec p) i a,
dbl_pt f i a->
(forall j, dbl_pt_1 (fun v : Rvec p => f v j) i a).
Proof.
move => f i a H j.
rewrite /dbl_pt_1 .
rewrite /dbl_pt in H.
elim H => vl Hv.
exists (vl j).
rewrite echiv_der_p in Hv.
apply Hv.
Qed.


Lemma eq_der_p :
forall f i a pr ,
forall j, der_p f i a pr j = dp_1 (fun v => (f v) j) i a (echiv_der_p2 _ _ _ pr j) .
Proof.
move => f i a pr j.
rewrite /der_p /dp_1.
elim (echiv_der_p2 f i a pr j) => r Hg.
elim pr => v Hv.
rewrite //=.
rewrite echiv_der_p in Hv.
have Hv1 := Hv j.
rewrite /part_deriv_pt_1 in Hg Hv1.
by apply (uniq_lim_R 
   (fun t : Base R_met => (f (a +^ t *^ base_v i) j - f a j) / t) 0).
Qed.

Lemma eq_der_p2 :
forall (f:Rvec p ->Rvec p) i a pr j,
 dp_1 (fun v => (f v) j) i a (pr j) =  der_p f i a (echiv_der_p1 _ _ _ pr) j  .
Proof.
move => f i a pr j.
rewrite /der_p /dp_1.
elim (echiv_der_p1 f i a pr) => v Hv.
elim (pr j) => r Hr.
rewrite //=.
rewrite echiv_der_p in Hv.
have Hv1 := Hv j.
rewrite /part_deriv_pt_1 in Hr Hv1.
by apply (uniq_lim_R 
   (fun t : Base R_met => (f (a +^ t *^ base_v i) j - f a j) / t) 0).
Qed.

Definition funJ (f:Rvec p-> Rvec p) (a:Rvec p)  (pr :forall i, dbl_pt f i a) :=
fun i j => der_p f i a (pr i) j.

Definition Jac (f:Rvec p-> Rvec p) (a:Rvec p) pr:=
\matrix_(i, j) (der_p f j a (pr j) i : real_field).



(*linearity of the derivation operator*)
Lemma echiv_deriv_sum:
forall (f: I_(p) -> (Rvec p -> R)) i a dp,
(forall x : I_(p), part_deriv_pt_1 (f x) i a (dp x))->
part_deriv_pt_1 (fun v : Rvec p => \sum_(j) f j v) i a (\sum_(j) dp j).
Proof.
move => f i a dp.
rewrite /part_deriv_pt_1 /limit_R /limit_gen.
move => H eps He.
have H': forall  (eps : R),
    eps > 0 -> forall (x : I_(p)),
    exists alp : R,
      alp > 0 /\
      (forall x0 : Base R_met,
       0 < dist R_met x0 0 < alp ->
       dist R_met ((f x (i +^ x0 *^ base_v a) - f x i) / x0) (dp x) < eps).
move => q w r; apply (H r q w).
have Hep: eps/INR p >0.
have Hp1: 0<INR p.
by apply lt_INR_0; exact Hp.
rewrite /Rdiv.
apply Rmult_gt_0_compat; [done|].
rewrite /Rgt.
by apply Rinv_0_lt_compat.

elim (choice (fun x alp => alp > 0 /\
        (forall x0 : Base R_met,
         0 < dist R_met x0 0 < alp ->
         dist R_met ((f x (i +^ x0 *^ base_v a) - f x i) / x0) (dp x) < eps/INR p)) 
  (H' (eps/INR p) Hep))=> del Hdel.
exists (min_del del).
split.
apply: (min_ge0 Hp); move => j; by elim (Hdel j).
move => r Hr.
rewrite /dist //= /R_dist /Rdiv in Hdel |-*.
have Heq : (\sum_(j < p) f j (i +^ r *^ base_v a) - \sum_(j < p) f j i) */ r  = 
((\sum_(j < p) f j (i +^ r *^ base_v a) )*/ r - (\sum_(j < p) f j i) */ r )%Ri.
rewrite Rmult_plus_distr_r.
by simp_R.
rewrite Heq !big_distrl //= -sum_split_sub //=.
have Heq1: (\sum_(i0 < p) (f i0 (i +^ r *^ base_v a) * / r - f i0 i * / r)%Ri -
   \sum_(j < p) dp j) = (\sum_(i0 < p) (f i0 (i +^ r *^ base_v a) * / r - f i0 i * / r) -
   \sum_(j < p) dp j)%Ri by simp_R.
rewrite Heq1 -sum_split_sub.
simp_R.
apply Rle_lt_trans with (\sum_(i0) Rabs ((f i0 (i +^ r *^ base_v a) * / r - f i0 i * / r
   - dp i0))).
apply: (abs_sum_le_f).
apply : (ineq_sum_el Hp).
 left; apply: He.
move => x.
replace (f x (i +^ r *^ base_v a) * / r - f x i * / r ) with 
((f x (i +^ r *^ base_v a)  - f x i) * / r ); [|by ring_simplify].
rewrite /Rdiv.
elim (Hdel x) => H1 H2.
apply: (H2 r).
elim Hr => Hr2 Hr1; rewrite /dist //= /R_dist in Hr1 Hr2.
split; [done|].
apply Rlt_le_trans with (min_del del); [done|apply min_min].
Qed.


Lemma echiv_dbl_sum:
forall (f: I_(p) -> (Rvec p -> R)) i a,
(forall x : I_(p), dbl_pt_1 (f x) i a)->
dbl_pt_1 (fun v : Rvec p => \sum_(j) f j v) i a.
Proof.
move => f i a H.
rewrite /dbl_pt_1 in H |-*.
have H1 :=H.
rewrite /part_deriv_pt_1 in H.
have Hg: {dp:I_(p) -> R & forall x:I_(p), 
  limit_R (fun t : Base R_met => (f x (a +^ t *^ base_v i) - f x a) / t) 0
      (dp x)}.
exists (fun j=> let (dp, _) := H j in dp).
intros j; case (H j); auto.
elim Hg => dp Hdp.
exists (\sum_(j) dp j).
apply  echiv_deriv_sum.
move =>x.
rewrite /part_deriv_pt_1.
apply Hdp.
Qed.


Lemma lin_der_1:
forall (f: I_(p) -> (Rvec p -> R)) i a pr ,
dp_1 (fun v => \sum_(j) (f j v)) i a (echiv_dbl_sum _ _ _ pr) =
   \sum_(j) dp_1 (f j) i a (pr j).
Proof.
move => f i a pr.
rewrite part_der_pt_eq.
have H3 : forall x,  part_deriv_pt_1 (f x) a i (projT1 (pr x)).
move => x; apply (projT2 (pr x)).
have X: {dp: I_(p) -> R & forall x, dp x = projT1 (pr x)}.
exists (fun j => projT1 (pr j)).
move => x; done.
elim X => dp Hdp.
have Heq:   (\sum_(j) dp_1 (f j) i a (pr j)) =   (\sum_(j) dp j).
apply eq_bigr; move => j _; rewrite //=.
by rewrite /dp_1 -(Hdp j).
rewrite Heq.
apply echiv_deriv_sum.
move => x; rewrite (Hdp x); apply (H3 x).
Qed.

Lemma pr_eq_dif:
forall f i a pr1 pr2,
dp_1 f i a pr1 = dp_1 f i a pr2.
Proof.
move=> f i a pr1 pr2;
elim pr1 => pr1a pr1b;
elim pr2 => pr2a pr2b;
rewrite //=;
by apply (uniq_lim_R (fun t : Base R_met => (f (a +^ t *^ base_v i) - f a) / t) 0).
Qed.



Lemma lin_der_2:
forall (f: I_(p) -> (Rvec p -> R)) i a pr pr2 ,
dp_1 (fun v => \sum_(j) (f j v)) i a pr2 = \sum_(j) dp_1 (f j) i a (pr j).
Proof.
move => f i a pr pr2.
rewrite part_der_pt_eq.
have H3 : forall x,  part_deriv_pt_1 (f x) a i (projT1 (pr x)).
move => x; apply (projT2 (pr x)).
have X: {dp: I_(p) -> R & forall x, dp x = projT1 (pr x)}.
exists (fun j => projT1 (pr j)).
move => x; done.
elim X => dp Hdp.
have Heq:   (\sum_(j) dp_1 (f j) i a (pr j)) =   (\sum_(j) dp j).
apply eq_bigr; move => j _; rewrite //=.
by rewrite /dp_1 -(Hdp j).
rewrite Heq.
apply echiv_deriv_sum.
move => x; rewrite (Hdp x); apply (H3 x).
Qed.



(* second order partial derivatives; first for functions Rp -> R *)

Definition part_deriv_pt_1_2 f a i j (pr1: forall v, dbl_pt_1 f i v) dp2 :=
 part_deriv_pt_1 (fun v => dp_1 f i v (pr1 v)) a j dp2.

(*pr1 should say that f is partially derivable in a neighbourhood of a*)

Definition   dbl_pt_1_2 (f:(Rvec p)->R) (i j:I_(p)) (a:(Rvec p)) pr1:=
sigT (part_deriv_pt_1_2 f a i j pr1).

Definition dp_1_2 f i j a pr1 (pr2: dbl_pt_1_2 f i j a pr1) :=
projT1 pr2.

Definition sum_dp2_v 
     f a v (pr: forall i v, dbl_pt_1 f i v) (pr2: forall i j, dbl_pt_1_2 f i j a (pr i)):=
\sum_(j) \sum_(i) dp_1_2 f i j a (pr i) (pr2 i j) * v i*v j.

Lemma deriv_2_impl_1:
forall f a i j pr1 dp2,
part_deriv_pt_1_2 f a i j pr1 dp2 ->
part_deriv_pt_1 f a i (projT1 (pr1 a)).
Proof.
move => f a i j pr1 dp2 H.
case (pr1 a); rewrite //=.
Qed.

Lemma dbl_2_impl_1:
forall f a i j pr1,
dbl_pt_1_2 f i j a pr1 ->
dbl_pt_1 f i a.
Proof .
move => f a i j pr1 H.
exists (projT1 (pr1 a)).
apply deriv_2_impl_1 with j (projT1 H).
exact: projT2 H.
Qed.

Lemma deriv_2_impl_der_1:
forall f a i j pr1 dp2,
part_deriv_pt_1_2 f a i j pr1 dp2 ->
part_deriv_pt_1 (fun v => dp_1 f i v (pr1 v)) a j dp2.
Proof.
move => f a i j pr1 dp2 H.
by rewrite /part_deriv_pt_1_2 in H.
Qed.

Lemma dbl_2_impl_dp_dp_1:
forall f a i j (pr1:forall v, dbl_pt_1 f i v),
dbl_pt_1_2 f i j a pr1 ->
dbl_pt_1 (fun v => dp_1 f i v (pr1 v)) j a.
Proof.
move=> f a i j pr1 H.
elim H => dp2 Hdp2.
by exists dp2; apply deriv_2_impl_der_1.
Qed.

Lemma dp_2_impl_dp_1:
forall f a i j pr1 pr2 ,
dp_1_2 f i j a pr1 pr2 = dp_1 (fun v => dp_1 f i v (pr1 v)) j a pr2.
Proof.
move => f a i j pr1 pr2 .
rewrite /dp_1_2.
case (pr2) ; rewrite //=.
Qed.


Lemma pr_impl1:
forall f v pr dp2,
(forall x i j, (part_deriv_pt_1_2 f x i j (pr i) (dp2 x i j))) ->
forall i j x, part_deriv_pt_1 (fun w : Rvec p => dp_1 f i w (pr i w) * v i) x j (v i*(dp2 x i j)).
Proof.
move => f v pr dp2  H i j x.
have H':= H x i j.
rewrite /part_deriv_pt_1_2 in H'.
rewrite /part_deriv_pt_1 in H' |- *.
have Heqf: forall t, (dp_1 f i (x +^ t *^ base_v j) (pr i (x +^ t *^ base_v j)) * v i -
    dp_1 f i x (pr i x) * v i) / t=
v i*((dp_1 f i (x +^ t *^ base_v j) (pr i (x +^ t *^ base_v j))  -
    dp_1 f i x (pr i x)) / t).
move => t; rewrite /Rdiv; by ring_simplify.
rewrite /limit_R. 
rewrite (echiv_lim_f R_met R_met (fun t : Base R_met =>
   (dp_1 f i (x +^ t *^ base_v j) (pr i (x +^ t *^ base_v j)) * v i -
    dp_1 f i x (pr i x) * v i) / t) 
  (fun t =>v i*((dp_1 f i (x +^ t *^ base_v j) (pr i (x +^ t *^ base_v j)) -
        dp_1 f i x (pr i x)) / t) ) 0 (v i*(dp2 x i j)) Heqf).
fold (limit_R  (fun t : Base R_met =>
   (dp_1 f i (x +^ t *^ base_v j) (pr i (x +^ t *^ base_v j)) -
    dp_1 f i x (pr i x)) / t * v i) 0 ((dp2 x i j) * v i)).
by apply: limit_R_multc.
Qed.


Lemma pr_impl2: forall f (v:Rvec p) pr,
(forall x i j , dbl_pt_1_2 f i j x (pr i)) ->
forall (i j: I_(p)) (x : Rvec p),
  dbl_pt_1 (fun w : Rvec p => dp_1 f i w (pr i w)* v i) j x.
Proof.
move=> f v pr H1 i j w.
have X:{dp2:Rvec p-> I_(p)->I_(p) -> R&forall x i0 j0,dp2 x i0 j0 = projT1 (H1 x i0 j0)}.
exists (fun x i0 j0 => projT1 (H1 x i0 j0)); move =>*;done.
elim X=> dp2 Hd2.
exists (v i* dp2 w i j).
 apply pr_impl1.
move=> x i0 j0; rewrite Hd2 ;exact (projT2 (H1 x i0 j0)).
Qed.


Lemma pr_impl:
forall f v pr, 
(forall x i j , dbl_pt_1_2 f i j x (pr i)) ->
forall (i : I_(p)) (x : Rvec p),
  dbl_pt_1 (fun w : Rvec p => sum_dp_v f w v pr) i x.
Proof.
move =>f  v pr H i x.
rewrite /sum_dp_v.
apply echiv_dbl_sum.
move =>j.
have Hy:= projT2 (H x j i).
have X: {dp:Rvec p -> I_(p) -> I_(p) ->R & forall x i0 j0, dp x i0 j0 = projT1 (H x i0 j0)}.
exists (fun x i j => projT1 (H x i j)).
move => *; done.
elim X=> dp Hdp.
exists (v j* dp x j i).
apply: pr_impl1.
move => x0 i0 j0; rewrite Hdp.
exact: projT2 (H x0 i0 j0).
Qed.


(*
in the 2 previous lemmas, maybe it's enough to state 
that the fun is twice derivable only in a point a,
and not forall x:Rvec p 


Lemma eq_sum_dp3:
forall f (a v:Rvec p) pr1 pr2 j,
\sum_(i0) dp_1_2 f i0 j a (pr1 i0) (pr2 a i0 j) * v i0 * v j =
dp_1 (fun w : Rvec p => sum_dp_v f w v pr1) j a
  (pr_impl f v pr1 pr2 i a) * v j.

*)

Lemma eq_sum_dp2_gen1:
forall f (a v:Rvec p) pr1 pr2 i,
\sum_(i0) dp_1_2 f i0 i a (pr1 i0) (pr2 a i0 i) * v i0  =
dp_1 (fun w : Rvec p => sum_dp_v f w v pr1) i a
  (pr_impl f v pr1 pr2 i a).
Proof.
move=> f a v pr1 pr2 i.
have Heqf: forall j, dp_1_2 f j i a (pr1 j) (pr2 a j i) * v j  = 
dp_1 (fun v => dp_1 f j v (pr1 j v)) i a (pr2 a j i) *v j .
move => j.
by rewrite Rmult_comm; apply Rmult_eq_compat_l.
have Heq2: \sum_(j) dp_1_2 f j i a (pr1 j) (pr2 a j i) * v j =
\sum_(j)  dp_1 (fun v : Rvec p => dp_1 f j v (pr1 j v)) i a (pr2 a j i) * v j .
by apply  eq_bigr .
rewrite Heq2.
have Heq: 
dp_1 (fun w : Rvec p => 
  \sum_(i0) dp_1 f i0 w (pr1 i0 w) * v i0) i a (pr_impl f v pr1 pr2 i a) = 
\sum_(j) dp_1  (fun v0 => dp_1 f j v0 (pr1 j v0)*v j) i a (pr_impl2 f v pr1 pr2 j i a).
apply: lin_der_2.
rewrite Heq.
have Heq3: (\sum_(j) dp_1 (fun v0 : Rvec p => dp_1 f j v0 (pr1 j v0) * v j) i a
            (pr_impl2 f v pr1 pr2 j i a)) =
((\sum_(j) dp_1 (fun v0 : Rvec p => dp_1 f j v0 (pr1 j v0) * v j) i a
            (pr_impl2 f v pr1 pr2 j i a)) )%Ri by simp_R.
apply: eq_bigr=> j _.
rewrite dp_mul_const.
apply:  pr_eq_dif.
Qed.


Lemma eq_sum_dp2_gen:
forall f (a v:Rvec p) pr1 pr2 i,
\sum_(i0) dp_1_2 f i0 i a (pr1 i0) (pr2 a i0 i) * v i0 * v i =
dp_1 (fun w : Rvec p => sum_dp_v f w v pr1) i a
  (pr_impl f v pr1 pr2 i a) * v i.
Proof.
move=> f a v pr1 pr2 i.
have Heqf: forall j, dp_1_2 f j i a (pr1 j) (pr2 a j i) * v j * v i = 
dp_1 (fun v => dp_1 f j v (pr1 j v)) i a (pr2 a j i) *v j * v i.
move => j.
by rewrite Rmult_comm; apply Rmult_eq_compat_l.
have Heq2: \sum_(j) dp_1_2 f j i a (pr1 j) (pr2 a j i) * v j * v i =
\sum_(j)  dp_1 (fun v : Rvec p => dp_1 f j v (pr1 j v)) i a (pr2 a j i) * v j *
       v i.
by apply  eq_bigr .
rewrite Heq2.
have Heq: 
dp_1 (fun w : Rvec p => 
  \sum_(i0) dp_1 f i0 w (pr1 i0 w) * v i0) i a (pr_impl f v pr1 pr2 i a) = 
\sum_(j) dp_1  (fun v0 => dp_1 f j v0 (pr1 j v0)*v j) i a (pr_impl2 f v pr1 pr2 j i a).
apply: lin_der_2.
rewrite Heq.
have Heq3: (\sum_(j) dp_1 (fun v0 : Rvec p => dp_1 f j v0 (pr1 j v0) * v j) i a
            (pr_impl2 f v pr1 pr2 j i a)) * v i=
((\sum_(j) dp_1 (fun v0 : Rvec p => dp_1 f j v0 (pr1 j v0) * v j) i a
            (pr_impl2 f v pr1 pr2 j i a)) * v i)%Ri by simp_R.
rewrite Heq3 big_distrl; simp_R.
apply: eq_bigr=> j _.
rewrite dp_mul_const.
 congr (_*_).
apply:  pr_eq_dif.
Qed.


Lemma eq_sum_dp2:
forall f a v pr pr2 ,
sum_dp2_v f a (v:Rvec p) pr (pr2 a) = 
sum_dp_v (fun w => sum_dp_v f w v pr ) a v (pr_impl f v pr (pr2 )).
Proof.
move => f a v pr1 pr2.
rewrite /sum_dp2_v {1}/sum_dp_v.
apply eq_bigr => i _; apply eq_sum_dp2_gen.
Qed.


Lemma part_der12_derivable_pt_abs2:
forall f a (v:Rvec p) t  pr (pr2:forall x i j, dbl_pt_1_2 f i j x (pr i))
(Hc: forall (i : I_(p)) (v : Base (Rp_met p)),
   cont_Rp_R  (fun x : Rvec p => dp_1 f i x (pr i x)) v),
(forall (i : I_(p)) (v0 : Base (Rp_met p )),
cont_Rp_R 
  (fun x : Rvec p =>
   dp_1 (fun w : Rvec p => sum_dp_v f w v pr) i x (pr_impl f v pr pr2 i x))
  v0)->
derivable_pt_lim (fun y => derive_pt 
(fun t : R => f (add_v a (mult_sv t v))) y (der_pt_sum_t f a v pr y Hc )) t 
(sum_dp2_v f (a +^t*^v) (v:Rvec p) pr (pr2 (a+^t*^v))) .
Proof.
move => f a v t  pr pr2 Hc Hc2 .
rewrite eq_sum_dp2.
apply lim_der_eq with (fun y:R => (fun w : Rvec p => sum_dp_v f w v pr) (a+^y*^v)).
move =>x;by rewrite equiv_lim_t.
by apply: lim_der_t.
Qed.

Lemma dbl_pt_1_2_derivable_pt2:
forall f a (v:Rvec p) t  pr (pr2:forall x i j, dbl_pt_1_2 f i j x (pr i))
(Hcont1: forall (i : I_(p)) (v : Base (Rp_met p )),
   cont_Rp_R  (fun x : Rvec p => dp_1 f i x (pr i x)) v),
(forall (i : I_(p)) (v0 : Base (Rp_met p )),
cont_Rp_R 
  (fun x : Rvec p =>
   dp_1 (fun w : Rvec p => sum_dp_v f w v pr) i x (pr_impl f v pr pr2 i x))
  v0)->
 derivable_pt
      (fun t1 : R =>
     derive_pt (fun t2 : R => f (a +^ t2 *^ v)) t1
       (der_pt_sum_t f a v pr t1 Hcont1)) t.
Proof.
move=> f a v t  pr pr2 Hc Hc2.
exists (sum_dp2_v f (a +^t*^v) (v:Rvec p) pr (pr2 (a+^t*^v))).
by apply part_der12_derivable_pt_abs2.
Qed.



Lemma der2_sum_dp2:
forall f a (v:Rvec p) t  pr3 
 (pr4: forall (x : Rvec p) (i j : I_(p)), dbl_pt_1_2 f i j x (pr3 i))
(Hcont2 :forall i (v0:Rvec p), cont_Rp_R  (fun x:(Rvec p) => 
dp_1 (fun w : Rvec p => sum_dp_v f w v pr3) i x ((pr_impl f v pr3 pr4) i x)) v0)
(Hcont1: (forall i v, cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr3 i x)) v)),
derive_pt (fun t1 => (derive_pt 
     (fun t2 =>f (add_v a (mult_sv t2 v))) t1 ((der_pt_sum_t f a  v pr3 t1 Hcont1) ))) t 
(dbl_pt_1_2_derivable_pt2 f a v t pr3 pr4 Hcont1 Hcont2)
 = sum_dp2_v f (a+^t*^v) v pr3 (pr4 (a+^t*^v)).
Proof.
move=> f a v t pr3 pr4 Hcont2 Hcont1.
rewrite eq_sum_dp2.
rewrite -(equiv_lim_t 
  (fun w : Rvec p => sum_dp_v f w v pr3) a v  (pr_impl f v pr3 pr4) t Hcont2) .
apply fun_eq_der_eq; move=> x.
rewrite -(equiv_lim_t f a v pr3 x Hcont1).
by apply fun_eq_der_eq; move=>y.
Qed.



Lemma der2_sum_dp2_gen:
forall f a (v:Rvec p) t  pr1 pr2 pr3 
 (pr4: forall (x : Rvec p) (i j : I_(p)), dbl_pt_1_2 f i j x (pr3 i)),
( forall i (v0:Rvec p), cont_Rp_R  (fun x:(Rvec p) => 
dp_1 (fun w : Rvec p => sum_dp_v f w v pr3) i x ((pr_impl f v pr3 pr4) i x)) v0)->
( (forall i v, cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr3 i x)) v))->
derive_pt (fun t1 => (derive_pt 
     (fun t2 =>f (add_v a (mult_sv t2 v))) t1 (pr1 t1))) t (pr2 t)
 = sum_dp2_v f (a+^t*^v) v pr3 (pr4 (a+^t*^v)).
Proof.
move=> f a v t pr1 pr2 pr3 pr4 Hcont2 Hcont1.
rewrite eq_sum_dp2.
rewrite -(equiv_lim_t 
  (fun w : Rvec p => sum_dp_v f w v pr3) a v  (pr_impl f v pr3 pr4) t Hcont2) .
apply fun_eq_der_eq; move=> x.
rewrite -(equiv_lim_t f a v pr3 x Hcont1).
by apply fun_eq_der_eq; move=>y.
Qed.



Lemma subt_2:
forall r t y,
r - t = y - t -> r = y.
Proof.
move=> r t y H.
rewrite /Rminus in H.
apply Rplus_eq_reg_l with (-t).
by rewrite Rplus_comm H Rplus_comm.
Qed.


Lemma Taylor_2p_gen:
forall f (a v:Rvec p) pr3 pr4,
( forall i (v0:Rvec p) , cont_Rp_R  (fun x:(Rvec p) => 
dp_1 (fun w : Rvec p => sum_dp_v f w v pr3) i x ((pr_impl f v pr3 pr4) i x)) v0) ->
( (forall i v , cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr3 i x)) v))->
exists c:Rvec p,
f (a+^v) = f a + sum_dp_v f a v pr3 + 1/2* (sum_dp2_v f c v pr3 (pr4 c)).
Proof.
move=> f a v pr pr2 Hc2 Hc.
have hc1: (forall  v i , cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr i x)) v).
move=>*; apply Hc.
rewrite -(equiv_lim2 _ _ _ _ Hc).

have Hd2: forall x : R,
               derivable_pt
                 (fun y : R =>
                  derive_pt (fun t : R => f (a +^ t *^ v)) y ((der_pt_sum_t f a v pr y Hc))) x.
by move=> x; apply dbl_pt_1_2_derivable_pt2 with pr2.
have Hc0: forall x : R,
      continuity_pt
        (fun y : R =>
         derive_pt (fun t : R => f (a +^ t *^ v)) y
           (der_pt_sum_t f a v pr y Hc)) x.
by move=>x; apply derivable_continuous_pt.
have Ht: R0 < R1.
by fourier.
elim (Taylor2_v2 (fun t=> f (a+^t*^v)) (fun y =>(der_pt_sum_t f a v pr y Hc)) 
  Hc0 Hd2 R1 R0 Ht) => k [Hk1 Hk2] .
exists (a+^k*^v).
rewrite -(der2_sum_dp2 f a v k pr pr2 Hc2 Hc).
replace (f a) with (f (a+^0*^v));[|f_equal; by rewrite -ext_eq => i; rewrite !vxK; simp_R].
replace (a+^v) with (a+^1*^v);[|by rewrite -ext_eq => i; rewrite !vxK; simp_R].
rewrite Hk2.
ring_simplify.
rewrite !Rplus_assoc.
apply Rplus_eq_compat_l.
have Heq: (derive_pt (fun t : R => f (a +^ t *^ v)) 0 (der_pt_sum_t f a v pr 0 Hc) ) =
( derive_pt (fun t : R => f (a +^ t *^ v)) 0
  (der_pt_sum f a v pr (fun i : I_(p) => Hc i a)) ).
apply pr_nu.
rewrite Heq.
apply  Rplus_eq_compat_l.
replace (Rsqr (R1 - R0)) with R1;[|by rewrite /Rsqr; ring_simplify].
have Heq2: (derive_pt
  (fun y : R =>
   derive_pt (fun t : R => f (a +^ t *^ v)) y (der_pt_sum_t f a v pr y Hc)) k
  (Hd2 k) * 1 / 2) =  (1/2*derive_pt
  (fun y : R =>
   derive_pt (fun t : R => f (a +^ t *^ v)) y (der_pt_sum_t f a v pr y Hc)) k
  (Hd2 k) ).
field.
rewrite Heq2.
apply Rmult_eq_compat_l.
apply pr_nu.
Qed.

Lemma Taylor_2p:
forall f (a v:Rvec p) pr3 pr4,
( forall i (v0:Rvec p) , cont_Rp_R  (fun x:(Rvec p) => 
dp_1 (fun w : Rvec p => sum_dp_v f w v pr3) i x ((pr_impl f v pr3 pr4) i x)) v0) ->
( (forall i v , cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr3 i x)) v))->
exists c:Rvec p,
f (a+^v) - f a - sum_dp_v f a v pr3 = 1/2* (sum_dp2_v f c v pr3 (pr4 c)).
Proof.
move=> f a v pr pr2 Hc2 Hc.
elim (Taylor_2p_gen f a v pr pr2 Hc2 Hc) => k Hk.
exists k.
rewrite Hk.
by ring_simplify.
Qed.

(*first hyp of cont should be concerning the second derivative*)

Lemma Taylor_1p:
forall f a v pr (Hcont: (forall i v, cont_Rp_R  (fun x:(Rvec p) => dp_1 f i x (pr i x)) v)),
exists c:Rvec p,
f (a+^v) - f a = sum_dp_v f c v pr.
Proof.
move=> f a v pr Hcont.
have H1: forall t:R, derive_pt 
 (fun t =>f (add_v a (mult_sv t v))) t (der_pt_sum_t f a  v pr t Hcont) = 
sum_dp_v f (a+^t*^v) v pr.
move=>t; apply equiv_lim_t.
have Hpr: derivable (fun t => f (a+^t*^v)).
 move=>x; exact  (der_pt_sum_t f a v pr x Hcont).
have H01: 0<1 ; simp_R. 
 fourier.
elim ( MVT_cor1 (fun t => f (a+^t*^v)) 0 1 Hpr H01) => t0 [Heq Hin].
exists (a+^t0*^v).
replace (1*^v) with v in Heq; [|by rewrite -ext_eq => i; rewrite !vxK Rmult_1_l].
replace (a+^0*^v) with a in Heq;
  [|by rewrite -ext_eq =>i; rewrite !vxK Rmult_0_l Rplus_0_r].
replace  (derive_pt (fun t : R => f (a +^ t *^ v)) t0 (Hpr t0) * (1 - 0)) with
 (derive_pt (fun t : R => f (a +^ t *^ v)) t0 (Hpr t0)) in Heq; [|simp_R; done].
rewrite -(H1 t0) Heq; apply pr_nu.
Qed.

(*now: second order derivatives for functions Rvec p -> Rvec p *)


Definition part_deriv_pt_2 f a i j (pr1: forall v, dbl_pt f i v) dp2 :=
 part_deriv_pt (fun v => der_p f i v (pr1 v)) a j dp2.

(*pr1 should say that f is partially derivable in a neighbourhood of a*)

Definition   dbl_pt_2 (f:(Rvec p)->Rvec p) (i j:I_(p)) (a:(Rvec p)) pr1:=
sigT (part_deriv_pt_2 f a i j pr1).

Definition der_p_2 f i j a pr1 (pr2: dbl_pt_2 f i j a pr1) :=
projT1 pr2.

Lemma deriv_2_impl_1_gen:
forall f a i j pr1 dp2,
part_deriv_pt_2 f a i j pr1 dp2 ->
part_deriv_pt f a i (projT1 (pr1 a)).
Proof.
move => f a i j pr1 dp2 H.
case (pr1 a); rewrite //=.
Qed.

Lemma echiv_der_p3:
forall (f:Rvec p -> Rvec p) i j ,
(forall a, dbl_pt f i a)->
(forall  a, dbl_pt_1 (fun v : Rvec p => f v j) i a).
Proof.
move => f i j H a.
rewrite /dbl_pt_1 .
rewrite /dbl_pt in H.
elim (H a)=> vl Hv.
exists (vl j).
rewrite echiv_der_p in Hv.
apply Hv.
Qed.

Lemma eq_der_p3:
forall f i a pr  j,
 der_p f i a (pr a) j = dp_1 (fun v => (f v) j) i a (echiv_der_p3 _ _ _ pr a ) .
Proof.
move => f i a pr j.
rewrite /der_p /dp_1.
elim (echiv_der_p3 f i j  pr) => v Hv.
elim (pr a) => r Hr.
rewrite //=.
rewrite echiv_der_p in Hr.
have Hv1 := Hr j.
rewrite /part_deriv_pt_1 in Hv Hv1.
by apply (uniq_lim_R 
   (fun t : Base R_met => (f (a +^ t *^ base_v i) j - f a j) / t) 0).
Qed.


Lemma echiv_der_p_gen: forall f a i j dp pr,
part_deriv_pt_2 f a i j pr dp <->
forall k, part_deriv_pt_1_2 (fun v => (f v) k) a i j (echiv_der_p3 f i k pr) (dp k).  
Proof.
move => f a i j dp pr.
rewrite /part_deriv_pt_2 /part_deriv_pt_1_2 .
rewrite echiv_der_p.
split; move=> Hip k; have Hipk:= Hip k.
rewrite /part_deriv_pt_1 in Hipk |-*.
apply echiv_lim_f1 with (f:= (fun t : Base R_met =>
         ( (der_p f i (a +^ t *^ base_v j) (pr (a +^ t *^ base_v j)) k -
           der_p f i a (pr a) k) / t) :Base R_met));[move => t; by rewrite !eq_der_p3|apply Hipk].
rewrite /part_deriv_pt_1 in Hipk |-*.
apply echiv_lim_f1 with (f:= (fun t : Base R_met =>
          ((dp_1 (fun v : Rvec p => f v k) i (a +^ t *^ base_v j)
             (echiv_der_p3 f i k pr (a +^ t *^ base_v j)) -
           dp_1 (fun v : Rvec p => f v k) i a (echiv_der_p3 f i k pr a)) / t)
 :Base R_met));[move => t; by rewrite !eq_der_p3|apply Hipk].
Qed.

Lemma echiv_der_p2_gen:
forall (f:Rvec p -> Rvec p) i j a pr,
dbl_pt_2 f i j a pr ->
(forall k, dbl_pt_1_2 (fun v : Rvec p => f v k) i j a (echiv_der_p3 f i k pr) ).
Proof.
move => f i j a pr H k.
rewrite /dbl_pt_1_2 .
rewrite /dbl_pt_2 in H.
elim H => vl Hv.
exists (vl k).
rewrite echiv_der_p_gen in Hv.
apply Hv.
Qed.

Lemma pr_impl_jac:
forall f  (pr: forall  a x, dbl_pt f x a) ,
forall (i i0 : I_(p)) (x : Rvec p),
      dbl_pt_1 (fun x0 : Rvec p => f x0 i) i0 x.
Proof.
move=> f  pr i j x.
exact (echiv_der_p2 f j x (pr x j) i).
Qed.

Lemma jac_to_sum:
forall (f:Rvec p-> Rvec p) (a v: Rvec p) pr,

(mult_mv (Jac f a (pr a)) v )= \vec_(i) sum_dp_v (fun x => f x i) a v (pr_impl_jac f  pr i).
Proof.
move=> f a v pr .
rewrite /Jac /mult_mv /sum_dp_v.
rewrite -ext_eq => i; rewrite !vxK.
apply eq_bigr => j _; rewrite !mxK.
congr (_ * _).
rewrite eq_der_p.
apply dp_1_pr_nu.
Qed.

(*rather silly: i should be more carefull with the proofs like pr_impl_jac etc.
this proof is essencially echiv_der_p2...
also; i have stronger hyp. for sum_dp_v (derivable anywhere, not just in 1 point;
this is not neccessary - i think*)


Lemma echiv_der_gen1:
forall f (pr : forall (v : Rvec p) (i0 : I_(p)), dbl_pt f i0 v) ,
(forall (i j:I_(p)) (a:Rvec p), dbl_pt_2 f i j a (fun v => pr v i) ) ->
forall k a i j, (dbl_pt_1_2 (fun v : Rvec p => f v k) i j a (echiv_der_p3 f i k (fun v => pr v i)) ).
Proof.
move=> f pr H K a i j .
apply echiv_der_p2_gen; apply H.
Qed.

Lemma echiv_der_gen:
forall f (pr : forall (v : Rvec p) (i0 : I_(p)), dbl_pt f i0 v) ,
(forall (i j:I_(p)) (a:Rvec p), dbl_pt_2 f i j a (fun v => pr v i) ) ->
forall k a i j, (dbl_pt_1_2 (fun v : Rvec p => f v k) i j a (pr_impl_jac f pr k i)).
Proof.
move=> f pr H k a i j .
have H1:= echiv_der_gen1 f pr H k a i j.
red in H1 |-*.
elim H1 => x Hx.
exists x.
red in Hx |-*.
red in Hx |-*.
apply  echiv_lim_f1 with (f:=(fun t : Base R_met =>
        ((dp_1 (fun v : Rvec p => f v k) i (a +^ t *^ base_v j)
           (echiv_der_p3 f i k (fun v : Rvec p => pr v i)
              (a +^ t *^ base_v j)) -
         dp_1 (fun v : Rvec p => f v k) i a
           (echiv_der_p3 f i k (fun v : Rvec p => pr v i) a)) / t):Base R_met)).
by move=> t; rewrite (dp_1_pr_nu _ _ _  
(echiv_der_p3 f i k (fun v : Rvec p => pr v i) (a +^ t *^ base_v j))
 (pr_impl_jac f pr k i (a +^ t *^ base_v j))  ) 
(dp_1_pr_nu _ _ _ (echiv_der_p3 f i k (fun v : Rvec p => pr v i) a)
 (pr_impl_jac f pr k i a)).
done.
Qed.

Lemma dp_12_der_p2_eq:
forall f a (pr:(forall v i, dbl_pt f i v)) pr2 i j k,
der_p_2 f i j a (fun v => pr v i) (pr2 i j a) k =  
 (dp_1_2 (fun x : Rvec p => f x k) i j (a)
                           (pr_impl_jac f pr k i) (echiv_der_gen f pr pr2 k (a) i j)).
Proof.
move=> f a pr pr2 i j k.
case (pr2 i j a) => l1 Hl1 ; rewrite //=.
case (echiv_der_gen f pr pr2 k a i j) => l2 Hl2; rewrite //=.
rewrite echiv_der_p_gen in Hl1.
have Hl1k := Hl1 k.
rewrite /part_deriv_pt_1_2 /part_deriv_pt_1 in Hl1k Hl2.
have Hleq: limit_R
        (fun t : Base R_met =>
         (dp_1 (fun v : Rvec p => f v k) i (a +^ t *^ base_v j)
            (pr_impl_jac f pr k i (a +^ t *^ base_v j)) -
          dp_1 (fun v : Rvec p => f v k) i a (pr_impl_jac f pr k i a)) / t) 0
        (l1 k).
red; apply echiv_lim_f1 with (f:= (fun t : Base R_met =>
          ((dp_1 (fun v : Rvec p => f v k) i (a +^ t *^ base_v j)
             (echiv_der_p3 f i k (fun v : Rvec p => pr v i)
                (a +^ t *^ base_v j)) -
           dp_1 (fun v : Rvec p => f v k) i a
             (echiv_der_p3 f i k (fun v : Rvec p => pr v i) a)) / t):Base R_met ));[|done].
move=>t.
by rewrite (dp_1_pr_nu _ _ _  
(echiv_der_p3 f i k (fun v : Rvec p => pr v i) (a +^ t *^ base_v j))
 (pr_impl_jac f pr k i (a +^ t *^ base_v j))  ) 
(dp_1_pr_nu _ _ _ (echiv_der_p3 f i k (fun v : Rvec p => pr v i) a)
 (pr_impl_jac f pr k i a)).
apply  (uniq_lim_R _ _ _ _ Hleq Hl2).
Qed.


(*the following 2 lemmas should be in the min_max file*)

Lemma sum_pos_pos:
 forall f:I_(p)->R, 
(forall j, R0 <= f j)->
R0 <= \sum_(i) f i.
Proof.
move =>f H.
unlock reducebig.
move : (I_not_void p Hp).
elim: (index_enum I_(p)) =>//=.
move => x s IH1 _.
apply Rplus_le_le_0_compat.
apply H.
case A: (seq0 != s).
exact: IH1 A.
move/eqP: A =>A; rewrite -A //=; by right.
Qed.

Lemma ineq_sum_inr:
forall  f c,
(forall (j:I_(p)), 0 <= f j <= c) ->
 (\sum_(j) (f j)) <= INR p *c.
Proof.
move=> f c H.
have H0: 0<=c.
 elim (H (I0 p Hp) ) =>ha hb;
 apply Rle_trans with (f  (I0 p Hp)); assumption.
replace (INR p) with (INR (card (index_enum I_(p)))).
unlock reducebig.
move: I_not_void.
move: (uniq_enum I_(p)).
rewrite /index_enum.
elim (enum) => //=.
move => _ H1.
apply Rmult_le_pos; [apply pos_INR|done].
move => x s IH IHand Hdep .
move/andP :IHand =>IHand; elim IHand => Hdif Hun.
have Hcard: (card (d:=I_(p)) (setU1 x s)) = ((S O)+card (d:=I_(p)) s)%nat.
rewrite cardU1.
rewrite Hdif //=.
rewrite Hcard.
rewrite S_O_plus_INR .
case Hdifl: (seq0 != s).
rewrite Rmult_comm Rmult_plus_distr_l //= Rmult_1_r .
apply Rplus_le_compat.
by elim (H  x).
rewrite Rmult_comm.
exact (IH Hun Hdep).
move/eqP: Hdifl => Hdifl.
rewrite -Hdifl //=.
rewrite Rmult_comm Rmult_plus_distr_l Rmult_1_r.
apply Rplus_le_compat .
by elim (H x).
apply Rmult_le_pos; [done|apply pos_INR].
f_equal.
rewrite /index_enum.
have HeqsA: filter (setA I_(p)) (enum I_(p)) =1 setA I_(p) by apply filter_enum.
have HeqsE: filter (setA I_(p)) (enum I_(p)) = enum I_(p) by apply filter_setA.
rewrite HeqsE in HeqsA.
have Hc: (card (d:=I_(p)) (FinType.enum I_(p))) = (card (d:=I_(p)) (setA I_(p))).
by apply eq_card.
rewrite Hc.
apply card_ordinal.
Qed.

Lemma ineq_max_sum_inr:
forall  f c,
(forall (i j:I_(p)), 0 <= f i j <= c) ->
\big[Rmax/0]_(i) (\sum_(j) (f i j)) <= INR p *c.
Proof.
move=> f c H.
elim (max_exists p Hp (fun i =>  (\sum_(j) f i j))) => i;
[move=> Hi|apply sum_pos_pos => j; elim (H i j)=>*; done].
rewrite Hi.
by apply ineq_sum_inr.
Qed.



Lemma lemme1:
forall f (a v:Rvec p) c pr,
(forall (i j i0 : I_(p)) (v0 : Base (Rp_met p )),
cont_Rp_R  (fun x : Rvec p => dp_1 (f i j) i0 x (pr i j i0 x)) v0)->
(forall x (i j:I_(p)), \sum_ (k<p) Rabs (dp_1 (f i j)  k x (pr i j k x)) <= c) ->
norm_m ( dif_m (\matrix_(i, j) f i j (a+^v))  (\matrix_(i, j) f i j a) ) <= INR p * norm v *c.
Proof.
move=> f a v c pr Hc H.
have H1: forall i j, exists c, f i j (a +^ v) - f i j a = sum_dp_v (f i j) c v (pr i j).
move=> i j; apply Taylor_1p; exact (Hc i j).
have H2: forall i, exists c1:I_(p)->Rvec p, forall j,  
f i j (a +^ v) - f i j a = sum_dp_v (f i j) (c1 j) v (pr i j).
move=> i.
apply choice with (A:= I_(p)) (B:=Rvec p)
 (R:= fun j x => f i j (a +^ v) - f i j a = sum_dp_v (f i j) x v (pr i j) ).
move=>j; apply (H1 i j).
have H3:= choice  _ H2.
elim H3 => ch Hch.
apply Rle_trans with (norm_m (\matrix_(i, j) sum_dp_v (f i j) (ch i j) v (pr i j))).
right; f_equal; apply/matrixP => i j; rewrite !mxK; exact (Hch i j).
rewrite /norm_m /sum_dp_v /sum_abs.
apply Rle_trans with (\big[Rmax/0]_(i) (\sum_(j) 
               ((\sum_(i1) Rabs (dp_1 (f i j) i1 (ch i j) (pr i j i1(ch i j)) *
                                                                           v i1))) ) ).
apply (Rmax_le_f_le ) => i; apply (sum_le_f_le ) => j; rewrite !mxK.
apply (abs_sum_le_f ).
apply Rle_trans with (\big[Rmax/0]_(i) (\sum_(j) ( 
 (\sum_(i1) Rabs (dp_1 (f i j) i1 (ch i j) (pr i j i1(ch i j))) * Rabs (v i1))) ) ).
apply (Rmax_le_f_le ) => i; apply (sum_le_f_le ) => j; right;
apply eq_bigr =>i1 _ ; apply Rabs_mult.
apply Rle_trans with (\big[Rmax/0]_(i) ( \sum_(j) \sum_(i1) Rabs
                                       (dp_1 (f i j) i1 (ch i j)
                                          (pr i j i1 (ch i j))) *\big[Rmax/0]_(i2) Rabs (v i2))).
apply (Rmax_le_f_le ) => i; apply (sum_le_f_le ) => j;
apply (sum_le_f_le) => i1.
 apply Rmult_le_compat_l; [apply Rabs_pos|
apply max_max with (v:= fun j => Rabs ( v j)) => i0; apply Rabs_pos].
apply Rle_trans with (\big[Rmax/0]_(i) 
(\big[Rmax/0]_(i2) Rabs (v i2)* \sum_(j) \sum_(i1) Rabs
                                       (dp_1 (f i j) i1 (ch i j) (pr i j i1 (ch i j))))).
right; apply eq_bigr => i _.
rewrite Rmult_comm.
replace ((\sum_(j) \sum_(i1) Rabs (dp_1 (f i j) i1 (ch i j) (pr i j i1 (ch i j)))) *
\big[Rmax/0]_(i2) Rabs (v i2)) with 
(((\sum_(j) \sum_(i1) Rabs (dp_1 (f i j) i1 (ch i j) (pr i j i1 (ch i j)))) *
\big[Rmax/0]_(i2) Rabs (v i2))%Ri); [|by simp_R].
rewrite big_distrl //=; apply: eq_bigr => j _ ;rewrite big_distrl //=.
rewrite -distr_mult_max -/(norm v); [|apply (norm_pos )].
ring_simplify; rewrite Rmult_assoc.
apply Rmult_le_compat_l; [apply (norm_pos )|].
apply ineq_max_sum_inr => i j; split;[|done].
apply sum_pos_pos => k; apply Rabs_pos.
Qed.

Notation "'MR_' p" := (matrix real_field p p)(at level 10).
Notation "A -m B" := (dif_m A B) (at level 50, format "A  -m  B").
Notation "A ^-1m" := (invmx  A) (at level 10, format "A ^-1m") .



(*some lemmas to be moved in funsRp.v file*)

Lemma rel_cont_Rp_R_Rp:
forall (f:Rvec p -> Rvec p) x,
cont_Rp  f x -> forall i, cont_Rp_R  (fun v => f v i) x.
Proof.
move=> f x Hc i.
rewrite /cont_Rp /cont_gen /dist //= in Hc.
rewrite /cont_Rp_R /cont_gen /dist //=.
move=> eps He.
elim (Hc eps He) => alp [Ha1 Ha2].
exists alp; split; first by done.
move=> x0 Hx0.
have Ha3:= Ha2 x0 Hx0.
rewrite /dist_Rp in Ha3.
rewrite /R_dist; apply Rle_lt_trans with (norm (f x0 -^ f x));[|done].
have Heq: f x0 i - f x i = (f x0 -^ f x) i.
by rewrite !vxK.
rewrite Heq.
apply norm_max.
Qed.

Lemma rel_cont_R_Rp:
forall (f:Rvec p -> Rvec p) x,
( forall i, cont_Rp_R  (fun v => f v i) x) -> 
cont_Rp  f x.
Proof.
move=> f x Hc.
red in Hc |-*.
red in Hc |-*.

(*.
rewrite /cont_Rp /cont_gen /dist //= in Hc.
rewrite /cont_Rp_R /cont_gen /dist //=.
*)
move=> eps He.


rewrite /dist //= /dist_Rp /R_dist in Hc |-*.
have Hl1: forall eps, eps >0 -> forall i, exists alp, alp > 0 /\
            (forall x0 :  Rvec p,
             norm ( x0 -^  x) < alp -> Rabs (f x0 i - f x i)  < eps).
move=> e Hep i; exact  (Hc i e Hep).
have Hep: eps/INR p >0.
have Hp1: 0<INR p.
by apply lt_INR_0; exact Hp.
rewrite /Rdiv.
 apply Rmult_gt_0_compat; [done| ].
by apply: Rinv_0_lt_compat; apply lt_INR_0; exact Hp.

elim (choice (fun i alp => alp > 0 /\
          (forall x0 : Rvec p,
            norm (x0 -^ x) < alp -> Rabs (f x0 i - f x i) < eps)) (Hl1 (eps) He))=> cf Hrel.
exists (min_del cf) .
split.
apply: (min_ge0 Hp).
move => j; elim (Hrel j) => Hinq Hrest; apply: Hinq.
move =>v Hdist.
elim (norm_rew Hp (dif_v (f v) (f x))) => k Hk;
rewrite Hk vxK.
elim (Hrel k) => H1 H2.
apply (H2 v).
 apply Rlt_le_trans with (min_del cf); [done |apply min_min].
Qed.


Lemma con_of_der1:
forall (f:Rvec p -> Rvec p) pr,
(forall a i, cont_Rp  (fun x => der_p f i x (pr x i)) a)->

(forall (i i0 : I_(p)) (v0 : Base (Rp_met p )),
cont_Rp_R 
  (fun x : Rvec p => dp_1 (fun x0 : Rvec p => f x0 i) i0 x (pr_impl_jac f pr i i0 x)) v0).
Proof.
move=> f pr H i j v.
have H1:= H v j.
have Hc:= rel_cont_Rp_R_Rp 
     (fun x : Base (Rp_met p ) => der_p f j x (pr x j)) v H1 i.
have Heq1: forall x, der_p f j x (pr x j) i =
   dp_1 (fun x0 : Rvec p => f x0 i) j x (pr_impl_jac f pr i j x).
move=> x.
rewrite /der_p /dp_1.
elim (pr_impl_jac f pr i j x) => l Hl .
elim (pr x j) => r Hr.
rewrite //=.
rewrite echiv_der_p in Hr.
have Hv1 := Hr i.
rewrite /part_deriv_pt_1 in Hl Hv1.
by apply (uniq_lim_R 
   (fun t : Base R_met => (f (x +^ t *^ base_v j) i - f x i) / t) 0).
rewrite /cont_Rp_R /cont_gen in Hc |-*; move=> eps He.
elim (Hc eps He) => alp [Ha1 Ha2].
exists alp; split; first by done.
move=> x Hdx.
rewrite -(Heq1 x) -(Heq1 v); by apply Ha2.
Qed.

Lemma cont_of_der2:
forall (f: Rvec p -> Rvec p) pr pr2,
forall a i j, cont_Rp  (fun v => der_p_2 f i j v (fun x => pr x i) (pr2 i j v)) a ->
forall k, cont_Rp_R  (fun a0 => (dp_1_2 (fun x : Rvec p => f x k) i j (a0)
                           (pr_impl_jac f pr k i) (echiv_der_gen f pr pr2 k (a0) i j))) a.
Proof.
move=> f pr pr2 a i j H k.
have H1:= rel_cont_Rp_R_Rp (fun v : Base (Rp_met p ) =>
       der_p_2 f i j v (fun x : Rvec p => pr x i) (pr2 i j v)) a H k.
rewrite /cont_Rp_R /cont_gen in H1 |-* => eps He;
elim (H1 eps He) => alp [Ha1 Ha2]; exists alp; split;[done|move=> x Hx].
have Heq: forall x,  (dp_1_2 (fun x0 : Rvec p => f x0 k) i j x (pr_impl_jac f pr k i)
     (echiv_der_gen f pr pr2 k x i j)) = (der_p_2 f i j x (fun x0 : Rvec p => pr x0 i) (pr2 i j x) k).
by move => y; rewrite dp_12_der_p2_eq.
by rewrite (Heq x) (Heq a); apply Ha2.
Qed.


Lemma cont_of_sum_Rp_R:
forall (f:I_(p) -> Rvec p ->R) (a:Rvec p) ,
(forall i, cont_Rp_R  (f i) a ) -> cont_Rp_R  (fun v:Rvec p => \sum_(i<p) f i v) a.
Proof.
move=> f a H.
rewrite /cont_Rp_R /cont_gen in  H |-* => eps He.
have Hc: forall  (eps : R),
    eps > 0 -> forall (i : I_(p)),
    exists alp : R,
      alp > 0 /\
      (forall x : Base (Rp_met p ),
       dist (Rp_met p ) x a < alp -> dist R_met (f i x) (f i a) < eps).
by move=>*; apply H.
have Heinr: eps/INR p > 0.
have Hp1: 0<INR p.
by apply lt_INR_0; exact Hp.
rewrite /Rdiv.
apply Rmult_gt_0_compat; [done|].
rewrite /Rgt.
by apply Rinv_0_lt_compat.
elim (choice (fun i alp => alp > 0 /\
       (forall x : Base (Rp_met p ),
        dist (Rp_met p ) x a < alp -> dist R_met (f i x) (f i a) < eps/INR p)) (Hc (eps/INR p) Heinr))=> ch Hch.
exists (min_del ch ); split.
 apply: (min_ge0 Hp)=> i; elim (Hch i) => [H1 _]; done.
move=> v Hv.
rewrite //= /R_dist.
have heq: (\sum_(i < p) f i v - \sum_(i < p) f i a)= (\sum_(i < p) f i v - \sum_(i < p) f i a) %Ri.
by simp_R.
rewrite heq -sum_split_sub.
apply Rle_lt_trans with  (\sum_(i) Rabs (f i v - f i a)).
apply (abs_sum_le_f ).
apply: (ineq_sum_el Hp).
simp_R; fourier.
move=> x; elim (Hch x) =>[_ Hs]; apply: Hs; apply Rlt_le_trans with (min_del ch);
[done| apply min_min].
Qed. 


Lemma cont_of_prod_Rp_R:
forall (f: I_(p) -> Rvec p ->R) (a:Rvec p) v i,
( cont_Rp_R  (f i) a ) -> cont_Rp_R  (fun w => f i w* v i)  a.
Proof.
move=> f a v i H.
rewrite /cont_Rp_R /cont_gen in H |-* => eps He.
elim (Req_dec (v i) R0) => Hk0.
exists eps; split; first by done.
 move => x0 Hx0; rewrite Hk0;
by rewrite !Rmult_0_r  /dist //= /R_dist Rminus_0_r Rabs_R0.
have Her: eps/Rabs (v i) >0.

apply: Rmult_gt_0_compat ; [done|by apply: Rinv_0_lt_compat; apply Rabs_pos_lt].
 elim (H (eps/Rabs (v i))  Her) => alp [Ha1 Ha2];
exists (alp); split; first by done .
move=> x Hx.
rewrite /dist //= /R_dist (Rmult_comm (f i x) (v i)) (Rmult_comm (f i a) (v i)) -Rmult_minus_distr_l 
Rabs_mult Rmult_comm.
apply (Rmult_lt_reg_l (/Rabs (v i))).
by apply: Rinv_0_lt_compat; apply Rabs_pos_lt.
ring_simplify; rewrite Rmult_comm -Rmult_assoc.
rewrite Rinv_r; [| by apply Rgt_not_eq; apply: Rabs_pos_lt].
 rewrite Rmult_1_l.
rewrite Rmult_comm.
by apply: Ha2.
Qed.


Lemma cont_eq_fun:
forall f g a,
(forall x, f x = g x)->
cont_Rp_R  f a ->
@cont_Rp_R p  g a.
Proof.
by move=> f g1 a Hfg Hf;
rewrite /cont_Rp_R /cont_gen in Hf |-* =>eps He; elim (Hf eps He)=> alp [Ha1 Ha2]; 
exists alp; split; [done|move=>x Hx; rewrite -!Hfg; apply Ha2].
Qed.

Lemma cont_of_der22:
forall (f: Rvec p -> Rvec p) pr pr2,
(forall a i j, cont_Rp  (fun v => der_p_2 f i j v (fun x => pr x i) (pr2 i j v)) a )->
(forall (i i0 : I_(p)) (v v0 : Rvec p),
cont_Rp_R 
  (fun x : Rvec p =>
   dp_1 (fun w : Rvec p => sum_dp_v (fun x0 : Rvec p => f x0 i) w v (pr_impl_jac f pr i))
     i0 x (pr_impl (fun x0 : Rvec p => f x0 i) v (pr_impl_jac f pr i) ((echiv_der_gen f pr pr2 i) ) i0 x)) v0).
Proof.
move=> f pr pr2  H i i0 v a.
apply cont_eq_fun with 
(fun a => \sum_(i1) dp_1_2 (fun x0 : Rvec p => f x0 i) i1 i0 a
                  (pr_impl_jac f pr i i1) (echiv_der_gen f pr pr2 i a i1 i0) *
                v i1 ).
move=> x; apply eq_sum_dp2_gen1.
apply cont_of_sum_Rp_R.
move=> j.
apply (cont_of_prod_Rp_R (fun j  =>
fun v0 =>     dp_1_2 (fun x0 : Rvec p => f x0 i) j i0 v0 (pr_impl_jac f pr i j)
       (echiv_der_gen f pr pr2 i v0 j i0)) a v j ).
by apply cont_of_der2.
Qed.


Lemma lemme2:
forall (f: Rvec p -> Rvec p) (a v: Rvec p) c
(pr: forall (x : Rvec p) (x0 : I_(p)), dbl_pt f x0 x) (* once derivable*)
(pr2: forall (i j:I_(p)) (a:Rvec p), dbl_pt_2 f i j a (fun v => pr v i) ) (*twice der*) ,
(forall a i, cont_Rp  (fun x => der_p f i x (pr x i)) a) (*cont 1st der*)->
(forall a i j, cont_Rp  (fun v => der_p_2 f i j v (fun x => pr x i) (pr2 i j v)) a )->
(*cont 2nd der*)

(*this is unnecessary... but it simplifies stuff;*)
(forall (v0:Rvec p) (i j : I_(p)),
\sum_( k < p) Rabs (der_p_2 f j k v0 (fun v => pr v j) (pr2 j k v0) i) <=c) ->

norm  ((f (a+^v) -^ f a ) -^ (mult_mv (Jac f a (pr a)) v)) <= 1/2*INR p*Rsqr (norm v)*c.
Proof.
move=> f a v c pr  pr2  Hc1 Hcont2 Hbc.
have Hcont1: forall (i i0 : I_(p)) (v0 : Base (Rp_met p )),
cont_Rp_R 
  (fun x : Rvec p => dp_1 (fun x0 : Rvec p => f x0 i) i0 x (pr_impl_jac f pr i i0 x)) v0.
by apply con_of_der1.

rewrite jac_to_sum.
replace ((f (a +^ v) -^ f a) -^
   \vec_ (i)sum_dp_v (fun x : Rvec p => f x i) a v (pr_impl_jac f pr i)) with
(\vec_(i) ((f (a +^ v ) i) - (f a) i - sum_dp_v (fun x : Rvec p => f x i) a v (pr_impl_jac f pr i)));
[|by rewrite -ext_eq =>i; rewrite !vxK].
have Heq1: exists c:I_(p)->Rvec p, (\vec_ (i)  (f (a +^ v) i - f a i -
    sum_dp_v (fun x : Rvec p => f x i) a v (pr_impl_jac f pr i))) = 
\vec_(i) (1/2* (sum_dp2_v (fun x => f x i) (c i) v (pr_impl_jac f pr i) (echiv_der_gen f pr pr2 i (c i)))).
have Heq: exists c:I_(p)->Rvec p,forall i, (  (f (a +^ v) i - f a i -
    sum_dp_v (fun x : Rvec p => f x i) a v (pr_impl_jac f pr i))) = 
 (1/2* (sum_dp2_v (fun x => f x i) (c i) v (pr_impl_jac f pr i) (echiv_der_gen f pr pr2 i (c i)))).
apply choice with (A:= I_(p)) (B:=Rvec p) (R:=fun i c =>  (  (f (a +^ v) i - f a i -
    sum_dp_v (fun x : Rvec p => f x i) a v (pr_impl_jac f pr i))) = 
 (1/2* (sum_dp2_v (fun x => f x i) c v (pr_impl_jac f pr i) (echiv_der_gen f pr pr2 i c)))).
move=> i.
apply Taylor_2p with (f:= fun x=> f x i);
[move => i0 v0; apply: cont_of_der22; done|done].
by elim Heq => ch Hch; exists ch; rewrite -ext_eq=>i; rewrite !vxK Hch.
elim Heq1 => ch Hch; rewrite Hch.
elim (norm_rew Hp (\vec_ (i)
   (1 / 2 *
    sum_dp2_v (fun x : Rvec p => f x i) (ch i) v (pr_impl_jac f pr i) (echiv_der_gen f pr pr2 i (ch i))))) => i Hi.
rewrite Hi !vxK.
rewrite Rabs_mult Rabs_right;[|apply Rle_ge;apply:  Rmult_le_pos; auto with real] .
rewrite Rmult_assoc Rmult_assoc. apply Rmult_le_compat_l.
apply:  Rmult_le_pos; auto with real.
rewrite /sum_dp2_v.
apply Rle_trans with ( 
  \sum_(j) Rabs ( \sum_(k) dp_1_2 (fun x : Rvec p => f x i) k j (ch i) (pr_impl_jac f pr i k)
                       (echiv_der_gen f pr pr2 i (ch i) k j) * v k * v j)  ).
apply (abs_sum_le_f ).
apply Rle_trans with (\sum_(j) \sum_(i0)  Rabs 
         (dp_1_2 (fun x : Rvec p => f x i) i0 j (ch i) (pr_impl_jac f pr i i0) (echiv_der_gen f pr pr2 i (ch i) i0 j) * v i0 * v j)).
apply (sum_le_f_le ) => j; apply (abs_sum_le_f ).
apply Rle_trans with (\sum_(j) \sum_(i0) Rabs
                    (dp_1_2 (fun x : Rvec p => f x i) i0 j (ch i) (pr_impl_jac f pr i i0)
                       (echiv_der_gen f pr pr2 i (ch i) i0 j)) * Rabs (v i0) * Rabs( v j)).
apply (sum_le_f_le) => j; right;
apply eq_bigr =>i1 _ ; by rewrite !Rabs_mult.
apply Rle_trans with ( \sum_(j) \sum_(i0) Rabs
                    (dp_1_2 (fun x : Rvec p => f x i) i0 j (ch i) (pr_impl_jac f pr i i0)
                       (echiv_der_gen f pr pr2 i (ch i) i0 j)) *\big[Rmax/0]_(i2) Rabs (v i2)  * \big[Rmax/0]_(i2) Rabs (v i2)).
apply (sum_le_f_le ) => j; apply (sum_le_f_le ) => k.
rewrite !Rmult_assoc; apply Rmult_le_compat_l; [apply Rabs_pos|].
apply Rmult_le_compat .
apply Rabs_pos.
apply Rabs_pos.
apply max_max with (v:=fun j=> Rabs (v j)) =>i0; apply Rabs_pos.
apply max_max with (v:=fun j=> Rabs (v j)) =>i0; apply Rabs_pos.
apply Rle_trans with ((\sum_(j) \sum_(i0) Rabs
                    (dp_1_2 (fun x : Rvec p => f x i) i0 j (ch i) (pr_impl_jac f pr i i0)
                       (echiv_der_gen f pr pr2 i (ch i) i0 j))) * (\big[Rmax/0]_(i2) Rabs (v i2) *
                  \big[Rmax/0]_(i2) Rabs (v i2)))%Ri.
right; rewrite big_distrl //=.
apply : eq_bigr => j _.
rewrite big_distrl //=.
apply: eq_bigr => k _.
by rewrite Rmult_assoc; simp_R.
 rewrite -/(norm v) -/(Rsqr (norm v)).
apply Rle_trans with (INR p*c*Rsqr (norm v));[|right; by ring_simplify].
apply Rmult_le_compat_r;[apply Rle_0_sqr|].
have Heq: \sum_(j) \sum_(i0) Rabs
                     (dp_1_2 (fun x : Rvec p => f x i) i0 j (ch i)
                        (pr_impl_jac f pr i i0)
                        (echiv_der_gen f pr pr2 i (ch i) i0 j)) = 

\sum_(i0) \sum_(j) Rabs
                     (dp_1_2 (fun x : Rvec p => f x i) i0 j (ch i)
                        (pr_impl_jac f pr i i0)
                        (echiv_der_gen f pr pr2 i (ch i) i0 j)).
apply: exchange_big .
rewrite Heq.
apply ineq_sum_inr.
move=> j.
split.
apply Rle_trans with (Rabs (\sum_(j0) 
            (dp_1_2 (fun x : Rvec p => f x i) j j0 (ch i)
               (pr_impl_jac f pr i j) (echiv_der_gen f pr pr2 i (ch i) j j0))));
[apply Rabs_pos|apply (abs_sum_le_f )].


have Heq2: \sum_(j0) Rabs 
            (dp_1_2 (fun x : Rvec p => f x i) j j0 (ch i)
               (pr_impl_jac f pr i j) (echiv_der_gen f pr pr2 i (ch i) j j0))
=
\big[Rplus/0]_(k < p) Rabs
                              (der_p_2 f j k (ch i) (fun v : Rvec p => pr v j)
                                 (pr2 j k (ch i)) i).
by apply: eq_bigr => k _; congr (Rabs _); rewrite dp_12_der_p2_eq.
 rewrite Heq2; apply Hbc.
Qed.

(*
**hypoth Hbo is superfluous; constant c can be replaced with the norm 
of the second derivative 

*)

Lemma echiv_der_p4:
forall (f:Rvec p -> Rvec p) a ,
(forall i, dbl_pt f i a)->
(forall  j i, dbl_pt_1 (fun v : Rvec p => f v j) i a).
Proof.
move => f a H i j.
rewrite /dbl_pt_1 .
rewrite /dbl_pt in H.
elim (H j)=> vl Hv.
exists (vl i).
rewrite echiv_der_p in Hv.
apply Hv.
Qed.

Lemma norm_gt0:
forall v, vect0 p <> v ->
R0 < norm v.
Proof.
move=> v Hv.
have Hnp:= norm_pos  v.
elim Hnp => H1; [done|].
have Heq:  v = vect0 p.
by rewrite -(norm0 Hp)  H1.
elim Hv.
by rewrite Heq.
Qed.

(*

Lemma part_der_cont_1:
forall (f : Rvec p -> R) a , 
(forall i, dbl_pt_1 f i a ) ->
cont_Rp_R Hp f a.
Proof.
move=> f a H eps He.
rewrite /dist //= /R_dist /dist_Rp.
red in H.
have H1: forall i, exists dp, part_deriv_pt_1 f a i dp.
move=> i; elim (H i) => d Hd; exists d; exact Hd.
elim (choice (fun i dp =>  part_deriv_pt_1 f a i dp) H1) => dp Hdp.
red in Hdp; red in Hdp; red in Hdp.
rewrite /dist //= /R_dist in Hdp.




Lemma part_der_cont_cont:
forall (f : Rvec p -> Rvec p) a , 
(forall i, dbl_pt f i a ) ->
cont_Rp Hp f a.
Proof.
move=> f a  H.
apply rel_cont_R_Rp => i.
have Heq:= echiv_der_p4 f a H i.
move=> eps He.
red in Heq.
have Hch1: forall i0, exists l:R,  part_deriv_pt_1 (fun v : Rvec p => f v i) a i0 l.
move=> j; elim (Heq j) => l Hl; exists l; done.
elim (choice (fun i0 l => part_deriv_pt_1 (fun v : Rvec p => f v i) a i0 l) Hch1) =>
d Hd.
red in Hd; red in Hd; red in Hd.
have Hch2: forall eps , eps>0-> forall x,  exists alp : R,
        alp > 0 /\
        (forall x0 : Base R_met,
         0 < dist R_met x0 0 < alp ->
         dist R_met ((f (a +^ x0 *^ base_v x) i - f a i) / x0) (d x) < eps).
by move=> eps0 He0 x; apply Hd.
have Hch3:= Hch2 eps He.
elim (choice (fun x alp =>  alp > 0 /\
         (forall x0 : Base R_met,
          0 < dist R_met x0 0 < alp ->
          dist R_met ((f (a +^ x0 *^ base_v x) i - f a i) / x0) (d x) < eps)) Hch3)
=> alp_ch Ha1.
exists (min_del alp_ch); split.
apply: (min_ge0 Hp).
by move => j; elim (Ha1 j) => [k0 _].
move=> v Hv.
rewrite /dist //= /R_dist /dist_Rp in Ha1 Hv |-*.
have Hin: forall i, Rabs ((v  -^ a) i) < min_del alp_ch.
move=> k; apply Rle_lt_trans with (norm (v -^ a));
[apply norm_max|done] .
elim (norm_rew Hp (v -^ a)) => im Him.
 elim (Ha1 im) => [ha2 Ha].
have Ha3:= (Ha (v im - a im)).
rewrite Rminus_0_r in Ha3.
elim (classic (f v = f a)) => Hdec.
rewrite Hdec.
replace (f a i - f a i) with R0; [|by ring].
by rewrite Rabs_R0.
have H0: 0 < Rabs (v im - a im) < alp_ch im.
replace (v im - a im) with ((v -^a ) im);[|by rewrite !vxK].
split.
rewrite -Him.
apply norm_gt0.
have H1: v <> a.
move=> Heq0.
rewrite Heq0 in Hdec.
by elim Hdec.
move => Heq0.
have Heq2: v=a.
have Hext:= ext_eq p  v a .
rewrite -Hext => k.
rewrite -ext_eq in Heq0; have Heq3:= Heq0 k.
 rewrite !vxK in Heq3.
apply subt_2 with (a k).
by ring_simplify; rewrite Heq3.
by elim H1.
apply Rlt_le_trans with (min_del alp_ch).
apply Hin.
apply min_min.
have Ha4:= Ha3 H0.


(* look for proof that der => cont *)

*)
End deriv.





 



