(*Require Import ssreflect ssrbool funs eqtype ssrnat seq fintype.
Require Import tuple paths connect div .
Require Import groups group_perm zp ssralg ssrbig matrix.
*)
Require Import ssreflect ssrnat seq fintype ssrbool eqtype funs ssrbig matrix ssralg .

Require Import structRp.
Require Import Reals.
Require Import Fourier.
Require Import Ranalysis.
Require Import Classical.
Require Import Max.

Delimit Scope ring_scope with Ri.

(*general results on the set of indexes,  lemmas for min and max, 
some results on sums*)
Section rez.

Variable p: nat.
Hypothesis Hp: (O<p)%nat.


Lemma I_not_void: seq0!=index_enum I_(p).
Proof.
apply/negP.
unfold not => Heq.
move/eqP: Heq=>Heq.
have Hc: count (enum I_(p)) seq0 = count (enum I_(p)) (index_enum I_(p)).
rewrite  Heq; done.
have Hc0: forall G, count  G seq0  = O.
move => l.
elim l.
move => x s Ih; rewrite //=.
have Hce: count (enum I_(p)) seq0  = O .
apply (Hc0 (I_(p))(enum I_(p))).
rewrite Hc in Hce.
have Hcard: card (enum I_(p)) = O.
rewrite /card.
by rewrite /index_enum in Hce |-*.
have HeqsA: filter (setA I_(p)) (enum I_(p)) =1 setA I_(p) by apply filter_enum.
have HeqsE: filter (setA I_(p)) (enum I_(p)) = enum I_(p) by apply filter_setA.
rewrite HeqsE in HeqsA.
 have h: card (d:=I_(p)) (setA I_(p)) =card (d:=I_(p)) (FinType.enum I_(p)) .
by apply eq_card.
rewrite -h in Hcard. 
rewrite card_ordinal in Hcard.
have Hnp:~p=O.
omega.
elim Hnp.
assumption.
Qed.

Definition I0:I_(p).
move:I_not_void.
elim (index_enum I_(p)) => //.
Defined.



Lemma max_le:
forall a b c d, a<=c-> b<=d-> Rmax a b <= Rmax c d.
Proof.
move => a b c d Hac Hbd.
destruct (Rle_or_lt a b); destruct (Rle_or_lt c d).
replace (Rmax a b) with b; replace (Rmax c d) with d; first by fourier.
unfold Rmax; case (Rle_dec ); auto with real.
unfold Rmax; case (Rle_dec a b); auto with real.
unfold Rmax; case (Rle_dec c d); auto with real.
replace (Rmax a b) with b; replace (Rmax c d) with c;first by fourier.
unfold Rmax; case (Rle_dec c d); auto with real.
unfold Rmax; case (Rle_dec a b); auto with real.
unfold Rmax; case (Rle_dec c d); auto with real.
replace (Rmax a b) with a; replace (Rmax c d) with d;first by fourier.
unfold Rmax; case (Rle_dec c d); auto with real.
unfold Rmax; case (Rle_dec a b); auto with real.
unfold Rmax; case (Rle_dec c d); auto with real.
replace (Rmax a b) with a; replace (Rmax c d) with c;first by fourier.
unfold Rmax; case (Rle_dec c d); auto with real.
unfold Rmax; case (Rle_dec a b); auto with real.
unfold Rmax; case (Rle_dec c d); auto with real.
Qed.

Lemma Rmax_assoc: forall x y z, Rmax x (Rmax y z) = Rmax (Rmax x y) z.
Proof.
move=> x y z.
destruct (Rle_or_lt x y); destruct (Rle_or_lt y z); destruct (Rle_or_lt x z).
replace (Rmax y z) with z; [|unfold Rmax; case Rle_dec; auto with real].
replace (Rmax x y) with y; [|unfold Rmax; case Rle_dec; auto with real].
replace (Rmax x z) with z; [|unfold Rmax; case Rle_dec; auto with real].
replace (Rmax y z) with z; [|unfold Rmax; case Rle_dec; auto with real].
done.
have Hcontr: x<=z by fourier. 
have Hcontr2: ~x<=z by fourier.
contradiction.
replace (Rmax y z) with y; [|unfold Rmax; case Rle_dec; auto with real].
replace (Rmax x y) with y; [|unfold Rmax; case Rle_dec; auto with real].
unfold Rmax; case Rle_dec; auto with real.
replace (Rmax y z) with y.
replace (Rmax x y ) with y.
unfold Rmax; case (Rle_dec y z); auto with real.
unfold Rmax; case (Rle_dec x y); auto with real.
unfold Rmax; case (Rle_dec y z); auto with real.
replace (Rmax y z) with z.
replace (Rmax x y) with x.
done.
unfold Rmax; case (Rle_dec x y); auto with real.
unfold Rmax; case (Rle_dec y z); auto with real.
replace (Rmax y z) with z.
replace (Rmax x y) with x.
done.
unfold Rmax; case (Rle_dec x y ); auto with real.
unfold Rmax; case (Rle_dec y z); auto with real.
have Hc1: ~x<=z by fourier.
contradiction.
replace (Rmax y z) with y.
replace (Rmax x y) with x.
unfold Rmax; case (Rle_dec x z); auto with real.
unfold Rmax; case (Rle_dec x y ); auto with real.
unfold Rmax; case (Rle_dec y z); auto with real.
Qed.



Definition Rmax2 r1 r2: R :=
match (Rlt_le_dec R0 r1) with
|left _ => Rmax r1 r2
|right _ =>  
        match (Rlt_le_dec R0 r2) with 
              |left _ => Rmax r1 r2
              |right _=> Rmin r1 r2
              end
end.

Lemma com_rmax2:
commutative Rmax2.
Proof.
move=> x y; rewrite /Rmax2; case (Rlt_le_dec R0 x) => Hx;
case (Rlt_le_dec R0 y) => Hy; [by rewrite Rmax_comm |by  rewrite Rmax_comm|
 by rewrite Rmax_comm |by rewrite Rmin_comm].
Qed.

Lemma el_n_zerol:

 left_unit R0 Rmax2.
Proof.
move=> x ; rewrite /Rmax2; case (Rlt_le_dec R0 x) => Hx0;
case (Rlt_le_dec R0 R0) => H00.
case (Rlt_irrefl R0 H00).
rewrite /Rmax; case (Rle_dec R0 x) => h0x; auto with real.
case (Rlt_irrefl R0 H00).
rewrite /Rmin; case (Rle_dec R0 x) => h0x; auto with real.
Qed.

Lemma el_n_zeror:

 right_unit R0 Rmax2 .
Proof.
move=>x; rewrite com_rmax2; apply el_n_zerol.
Qed.

Lemma Rmax_left:
forall r1 r2, r2 <= r1 -> Rmax r1 r2 = r1.
Proof.
move=> r1 r2 H; rewrite /Rmax; case (Rle_dec r1 r2); auto with real.
Qed.

Lemma Rmax_right:
forall r1 r2, r1 <= r2 -> Rmax r1 r2 = r2.
Proof.
move=> r1 r2 H; rewrite /Rmax; case (Rle_dec r1 r2); auto with real.
Qed.

Lemma Rmax_le:
forall r1 r2 r, r1 <= r -> r2 <=r -> Rmax r1 r2 <= r.
Proof.
move=> r1 r2 r H1 H2;
rewrite /Rmax; case (Rle_dec r1 r2) =>H; fourier.
Qed.

Lemma Rmax_le2:
forall r1 r2 r, r1 <= r /\ r2 <=r <-> Rmax r1 r2 <= r.
Proof.
by move=> r1 r2 r; split; [move=> [H1 H2]|];
rewrite /Rmax; case (Rle_dec r1 r2) =>H; [fourier|fourier|
move=> H1; split; fourier|move=> H1; split;[|apply Rle_trans with r1;
[left; apply Rnot_le_lt|]]].
Qed.

Lemma Rmax_Rlt_el:
forall r1 r2 r, r < Rmax r1 r2 <-> r < r1 \/ r < r2.
Proof.
move=> r1 r2 r; split .
by rewrite /Rmax; case (Rle_dec r1 r2) =>H0 H; [right|left]. 
move=> H; case H => H1.
by  apply Rlt_le_trans with r1; [| apply RmaxLess1].
by  apply Rlt_le_trans with r2; [| apply RmaxLess2].
Qed.

(*
Lemma Rmax_Rle_el:
forall r1 r2 r, r <= Rmax r1 r2 <-> r <= r1 \/ r < r2.
Proof.
move=> r1 r2 r; split .
by rewrite /Rmax; case (Rle_dec r1 r2) =>H0 H; [right|left]. 
move=> H; case H => H1.
by  apply Rlt_le_trans with r1; [| apply RmaxLess1].
by  apply Rlt_le_trans with r2; [| apply RmaxLess2].
Qed.
*)

Lemma Rmin_left:
forall r1 r2, r1 <= r2 -> Rmin r1 r2 = r1.
Proof.
move=> r1 r2 H; rewrite /Rmin; case (Rle_dec r1 r2); auto with real.
Qed.

Lemma Rmin_right:
forall r1 r2, r2 <= r1 -> Rmin r1 r2 = r2.
Proof.
move=> r1 r2 H; rewrite /Rmin; case (Rle_dec r1 r2); auto with real.
Qed.


Lemma Rmin_le:
forall r1 r2 r, r1 <= r -> r2 <=r -> Rmin r1 r2 <= r.
Proof.
move=> r1 r2 r H1 H2;
rewrite /Rmin; case (Rle_dec r1 r2) =>H; fourier.
Qed.

Lemma Rmin_split:
forall a b, Rmin a b = a \/ Rmin a b = b.
Proof.
by move=> a b; rewrite /Rmin; case (Rle_dec a b) => Hab;
[left|right].
Qed.


(*
Lemma Rlt_Rmin:
forall r1 r2 r, r < r1 -> r2 <=r -> Rmin r1 r2 <= r.
Proof.
move=> r1 r2 r H1 H2;
rewrite /Rmin; case (Rle_dec r1 r2) =>H; fourier.
Qed.
*)

Lemma Rmin_assoc: forall x y z, Rmin x (Rmin y z) = Rmin (Rmin x y) z.
Proof.
move=> x y z.
destruct (Rle_or_lt x y).
replace (Rmin x y) with x ; [|unfold Rmin; case Rle_dec; auto with real].
 destruct (Rle_or_lt y z).
replace (Rmin y z) with y; [|unfold Rmin; case Rle_dec; auto with real].
replace (Rmin x y) with x;[|unfold Rmin; case Rle_dec; auto with real].
have H1: x<=z.
 apply Rle_trans with y; by fourier.
replace (Rmin x z) with x.
done.
unfold Rmin; case Rle_dec; auto with real.

replace (Rmin y z) with z; [done|unfold Rmin; case Rle_dec; auto with real].
replace (Rmin x y) with y; [|unfold Rmin; case Rle_dec; auto with real].
 destruct (Rle_or_lt y z).
replace (Rmin y z) with y; [|unfold Rmin; case Rle_dec; auto with real].
unfold Rmin; case Rle_dec; auto with real.
replace (Rmin y z) with z; [|unfold Rmin; case Rle_dec; auto with real].
have H3: z<x.
fourier.
unfold Rmin; case Rle_dec; auto with real.
Qed.

Lemma ass_max2 : associative Rmax2.
Proof.
move=> x y z.
rewrite {1 4}/Rmax2 ; case (Rlt_le_dec R0 x) => Hx0.
rewrite !(com_rmax2 _ z) /Rmax2; case (Rlt_le_dec R0 z) => Hz0.
rewrite !(Rmax_comm z _); apply Rmax_assoc.
case (Rlt_le_dec R0 y) => Hy0 //=.
 case (Rlt_le_dec R0 (Rmax x y))=> Hxy //=.
by rewrite !Rmax_assoc (Rmax_comm z _).
have h2 : ~ Rmax x y <= 0.
apply RIneq.Rlt_not_le; case (Rle_dec x y) => hxy;
apply Rlt_le_trans with x ; rewrite //=; apply RmaxLess1 .
by elim h2.
case (Rlt_le_dec R0 (Rmax x y))=> Hrxy.
rewrite Rmax_assoc (Rmax_comm z _) -Rmax_assoc.
rewrite Rmax_left ; [rewrite Rmax_left;[done|]|].
apply Rle_trans with R0;[by apply Rmax_le|by left].
apply Rle_trans with R0; [by apply Rmin_le|by left].
rewrite Rmax_left in Hrxy.
by case (RIneq.Rle_not_lt R0 x Hrxy).
by left; apply Rle_lt_trans with R0.

case (Rlt_le_dec R0 (Rmax2 y z)) => H2.
rewrite {1}/Rmax ; case (Rle_dec x (Rmax2 y z)) => Hxyz.
case (Rlt_le_dec R0 y) => Hy0.
by rewrite Rmax_right; [|left; apply Rle_lt_trans with R0].
rewrite {2}/Rmax2; case (Rlt_le_dec R0 (Rmin x y))=> Hmin.
have Hmin2: Rmin x y > 0 by rewrite //=.
rewrite Rmin_Rgt  in Hmin2; case Hmin2 => H0 H1.
by case (RIneq.Rle_not_lt R0 x ).
rewrite com_rmax2; rewrite /Rmax2;
case (Rlt_le_dec R0 z) => Hz0.
by rewrite Rmax_left;[rewrite Rmax_right;[|left; apply Rle_lt_trans with R0]| 
 left; apply Rle_lt_trans with R0].
rewrite /Rmax2  in H2.
move:H2.

case (Rlt_le_dec R0 y) => Hy01 H2.
rewrite Rmax_Rlt_el in H2; case H2 => H3.
by case (RIneq.Rle_not_lt R0 y ).
by case (RIneq.Rle_not_lt R0 z ).
move: H2.
case (Rlt_le_dec R0 z)=> H0z1 H2.
by case (RIneq.Rle_not_lt R0 z ).
case (Rmin_split y z) => hr; rewrite hr in H2.

by case (RIneq.Rle_not_lt R0  y).
by case (RIneq.Rle_not_lt R0  z).
have H1: x <= Rmax2 y z .
by left; apply Rle_lt_trans with R0.
by case Hxyz.

move: H2; rewrite {1}/Rmax2.
case (Rlt_le_dec R0 y) => H0y H2.


rewrite Rmax_right;[|apply Rle_trans with R0; fourier].
rewrite -Rmax_le2 in H2; case H2 => Hxy.
by case (RIneq.Rle_not_lt R0  y).

move:H2; rewrite {1}/Rmax2.
case (Rlt_le_dec R0 z) => H0z H2.
rewrite -Rmax_le2 in H2; case H2 => Hzy1 Hzy2.
by case (RIneq.Rle_not_lt R0  z).

case (Rlt_le_dec R0 y) => Hy0.
by case (RIneq.Rle_not_lt R0  y).

rewrite /Rmax2; case (Rlt_le_dec R0 (Rmin x y)) => Hmin.
case (Rmin_split x y) => H; rewrite H in Hmin.
by case (RIneq.Rle_not_lt R0  x).
by case (RIneq.Rle_not_lt R0  y).
case (Rlt_le_dec R0 z) => Hz0.
by case (RIneq.Rle_not_lt R0  z).
apply Rmin_assoc.
Qed.

(*
Structure law : Type := Law {
  operator : T -> T -> T;
  _ : associative operator;
  _ : left_unit unit operator;
  _ : right_unit unit operator
}.

Structure abelian_law : Type := AbelianLaw {
   law_of_abelian :> law;
   _ : commutative (operator law_of_abelian)
}.

*)

Canonical Structure is_mon_law:= Monoid.Law ass_max2 el_n_zerol el_n_zeror.

Canonical Structure is_ab_law:= Monoid.AbelianLaw com_rmax2.

Lemma Rmax_Rmax2:
forall x y, R0 <= x -> R0 <= y -> Rmax x y = Rmax2 x y.
Proof.
move=> x y Hx Hy; rewrite /Rmax2; case (Rlt_le_dec R0 x) => Hx0;
first by done.
case (Rlt_le_dec R0 y) => Hy0; first by done.
have Hex: x=R0. by apply Rle_antisym.
have Hey: y=R0. by apply Rle_antisym.
rewrite Hex Hey /Rmax /Rmin; case (Rle_dec R0 R0)=> H00; auto with real.

Qed.


Lemma sxbigD1 : forall j (P : I_(p) -> bool) F,
(forall i, R0 <= F i) ->
  P j -> \big[Rmax/R0]_(i<p | P i) ( (F i))
    = Rmax ( (F j))  (\big[Rmax/R0]_(i<p | P i && (i != j)) ( (F i))).
Proof.
move=>  j P F HF Pj.
have H1: forall P F, (forall i, R0 <= F i) ->
 \big[Rmax/0]_(i < p | P i) F i = \big[Rmax2/0]_(i < p | P i) F i.
move=>  P0 F0 Hf.
apply: (@big_ch_op _ (fun r => R0 <= r)_ _); first by right.
move=> x y Hx Hy; apply Rle_trans with x; [done| apply RmaxLess1].
move=> x y Hx Hy; rewrite /Rmax2; case (Rlt_le_dec R0 x) => Hx0; first by done.
case (Rlt_le_dec R0 y) => Hy0; first by done.
have Hex: x=R0. by apply Rle_antisym.
have Hey: y=R0. by apply Rle_antisym.
rewrite Hex Hey /Rmax /Rmin; case (Rle_dec R0 R0)=> H00; auto with real.
move=> i Hi; apply Hf.
rewrite !(H1 _ _ HF).
rewrite Rmax_Rmax2.
rewrite (bigD1 j) //=.
apply HF.
apply: big_prop; first by right.
by move=> x y Hx Hy; rewrite -Rmax_Rmax2 ; 
[ apply Rle_trans with x ;[|apply RmaxLess1]| |].
move=>*; apply HF.
Qed.

Lemma rmax4:
forall r1 r2 r3 r4,
r1<=r2 ->
r3<=r4 ->
Rmax r1 r3 <= Rmax r2 r4.
Proof.
move => r1 r2 r3 r4 H12 H34.
rewrite /Rmax; case (Rle_dec r1 r3); case (Rle_dec r2 r4); auto with real.
move => H1 H2.
apply Rle_trans with r4; auto with real.
move => H1 H2; by apply Rle_trans with r2.
Qed.

Lemma Rmax_le_f_le:
forall (f g: I_(p) ->R), (forall i, f i <= g i) ->
\big[Rmax/0]_(i) f i <= \big[Rmax/0]_(i) g i.
Proof.
move => f g Hfg .
by apply: big_rel; 
[right|move=>*; apply rmax4 |move=>*;apply Hfg].
Qed.

Lemma sum_le_f_le:
forall (f g: I_(p) ->R), (forall i, f i <= g i) ->
\sum_(i) f i <= \sum_(i) g i.
Proof.
by move => f g Hfg;  apply:big_rel;
[right|move=>*; apply Rplus_le_compat  |move=>*;apply Hfg].
Qed.


Lemma distr_mult_max:
forall (r:R) (f:I_(p)->R), R0<=r->
r* (\big[Rmax/0]_(j) (f j))= \big[Rmax/R0]_(j) (r*f j).
Proof.
move => r f Hr;
apply: (big_op_rel (@eq R) (fun x => Rmult r x));
[rewrite /Ring.zero //= ; ring|
by move=>a b c H1 H2; rewrite H1 -H2|
by move=>a b c H; rewrite H|].
move=> a b; rewrite /Rmax; case (Rle_dec a b) =>H; 
  case (Rle_dec (r*a) (r*b)) => Hra; try done;
  [by case Hra; apply Rmult_le_compat_l|
    case Hr => H1; [
by case H;apply Rmult_le_reg_l with r|
rewrite -H1; ring]].
Qed.


(*use this lemma for proving positive homogenity*)

Lemma max_exists:
forall f:I_(p)->R, (forall i, 0 <= f i)->
exists k,
\big[Rmax/0]_(j) (f j ) = f k.
Proof.
move => v Hv.
unlock reducebig.
move : I_not_void;rewrite /index_enum.
elim : (enum I_(p)) (uniq_enum I_(p)) => //=.
move => x s IH IHun _ .
move/andP: IHun => IHun; elim IHun => I1 I2.
case A:(seq0 != s).
elim (Rle_dec ((v x))
    (foldr (fun (i : ordinal p) (x0 : R) => Rmax ( (v i)) x0) R0 s)) => I3.
elim (IH I2 A) => k Hk.
exists k.
rewrite -Hk.
unfold Rmax at 1
; case (Rle_dec ( v x)
  (foldr (fun (i : ordinal p) (x0 : R) => Rmax ( v i) x0) 0 s) )
; auto with real.
exists x.
unfold Rmax at 1
; case (Rle_dec (v x)
  (foldr (fun (i : ordinal p) (x0 : R) => Rmax (v i) x0) 0 s) )
; auto with real.
exists x.
move/eqP :A=>A.
rewrite -A //=.
have H:= Hv x.
unfold Rmax; case (Rle_dec (v x) 0); auto with real.
Qed.

Lemma desc_max:forall v j, 
(forall i, 0 <= v i)->
\big[Rmax/0]_(i) (v i ) = Rmax (v j)
    (\big[Rmax/R0]_(i<p|i!=j) (v i)).
Proof.
by move=>v j H; apply sxbigD1 with 
  (P:=(fun _  :I_(p)=> true)) (j:=j) (F:= (fun t => (v t))).
Qed.


Lemma max_max: forall (v:I_(p)->R) i,
(forall i, 0 <= v i) ->
 v i <= \big[Rmax/0]_(j) (v j ). 
Proof.
move=> v i H; 
rewrite (desc_max v i H); apply RmaxLess1.
Qed.

Lemma distr_plus_max:
forall (r f:I_(p)->R), (forall i, 0<=r i)->
(forall i, 0<=f i)->
 (\big[Rmax/0]_(j) (f j + r j))<= \big[Rmax/0]_(j) (f j) + \big[Rmax/0]_(j) (r j).
Proof.
move => g f Hg Hf.
have Hfg: forall i, 0 <=f i + g i .
  move => i; apply Rplus_le_le_0_compat; [apply Hf|apply Hg].
elim (max_exists (fun i => f i + g i)) => xfg ;last by apply Hfg.
by move => H2; rewrite H2; apply Rplus_le_compat ; apply max_max.
Qed.

(*


Lemma max_assoc:
forall a b c: nat, max a (max b c) = max (max a b) c.
Proof.
move => a b c.
case (le_ge_dec a b) =>Hab.
replace (max a b) with b. 
case (le_ge_dec b c) => Hbc.
replace (max b c) with c.
replace (max a c) with c.
done.
rewrite eq_echiv.
 apply max_r; omega.
rewrite eq_echiv.
by apply max_r.
replace (max b c) with b.
by apply max_r.
rewrite eq_echiv.
by apply max_l.
rewrite eq_echiv.
by apply max_r.
replace (max a b) with a.
case (le_ge_dec a c) => Hac.
replace (max b c) with c.
done.
rewrite eq_echiv.
 apply max_r.
omega.
rewrite (max_l).
rewrite eq_echiv.
by apply max_l.
case (le_ge_dec b c) => Hbc.
 replace (max b c) with c.
omega.
rewrite eq_echiv.
by apply max_r.
replace (max b c ) with b. 
omega.
rewrite eq_echiv.
by apply max_l.
rewrite eq_echiv.
by apply max_l.
Qed.
*)



(*
Lemma nxbig_mkcond : forall P v,
  \big[max/O]_(i <p | P i) ( (v i)) =
     \big[max/O]_(i <p) (if P i then ((v i)) else O).
Proof.
unlock reducebig => P v.
 elim: (index_enum I_(p))  => //= i r -> .
case (P i).
done.
case : (foldr
     (fun (i0 : ordinal p) (x : nat) => max (if P i0 then v i0 else O) x)
     O r) ; rewrite //=.
Qed.


Lemma nxbig_split : forall  P F1 F2,
  \big[max/O]_(i <p | P i) (max ( (F1 i))  ( (F2 i))) =
max  (\big[max/O]_(i < p| P i) ((F1 i))) (\big[max/O]_(i <p | P i) ( (F2 i))).
Proof.
unlock reducebig => P F1 F2.
elim: (index_enum I_(p)) => /= [|i r ->]; first by done.

 case: (P i) => //=.
rewrite !max_assoc.
congr (max _ _).
rewrite -max_assoc.
rewrite (max_comm
( (F2 i))
     (foldr
        (fun (i0 : ordinal p) (x : nat) =>
         if P i0 then max ( (F1 i0)) x else x) O r)).
by rewrite max_assoc.
Qed.


Lemma nxbigID : forall (a : set I_(p)) (P : I_(p) -> bool) F,
  \big[max/O]_(i<p | P i) ( (F i))
    = max (\big[max/O]_(i<p | P i && a i) ( (F i))) 
        (\big[max/O]_(i<p | P i && ~~ a i) ((F i))).
Proof.
move=>  a P F.
rewrite !(nxbig_mkcond _ F).

 rewrite -nxbig_split.
 apply: eq_bigr => i.
case: (a i);rewrite //= andbT andbF =>*.
case (P i); [case (F i) => //=| done].
case (P i); [case (F i) => //=| done].
Qed.

Lemma nxbig_seq1 : forall (i : I_(p)) F,
  \big[max/O]_(j <- Seq i) ((F j)) =  (F i).
Proof. 
unlock reducebig => /=  i F.
by case (F i).
Qed.

Lemma nxbig_set1_eq : forall  (i : I_(p)) F,
  \big[max/O]_(j<p | i == j) ( (F j)) = ( (F i)).
Proof.
move=>  i F; move: (filter_enum (set1 i) i) (FinType.enumP i).
rewrite set11 count_filter -big_filter; move: (filter _ _); case=> [|j []] //.
by rewrite mem_seq1 nxbig_seq1; move/eqP->.
Qed.

Lemma nxbig_set1 : forall (i : I_(p)) P F,
  P =1 set1 i -> \big[max/O]_(j<p | P j) ( (F j)) =  (F i).
Proof. move=>  i P F; move/(eq_bigl _ _)->; exact: nxbig_set1_eq. Qed.


Lemma nxbigD1 : forall j (P : I_(p) -> bool) F,
  P j -> \big[max/O]_(i<p | P i) ( (F i))
    = max ( (F j))  (\big[max/O]_(i<p | P i && (i != j)) ( (F i))).
Proof.
move=>  j P F Pj; rewrite (nxbigID (set1 j)); congr (max _  _).
  by apply: nxbig_set1 => i; rewrite andbC; case: eqP => // <-.
by apply: eq_bigl => i; rewrite eq_sym.
Qed.

*)

Notation "'\max_' ( i < p | P ) F" := (\big[maxn/O%N]_(i < p | P) F): dnat_scope.
 Notation "'\max_' ( i < p ) F" := (\big[maxn/O%N]_(i < p) F):dnat_scope.
 
(*
  (at level 41, F at level 41, i, r at level 50,
   format "'\max_' ( i < p  |  P )  F") : dnat_scope.
Notation "'\max_' ( i ) F" := (\big[maxn/0%N]_(i) F) 
  (at level 41, F at level 41, i at level 50,
   format "'\max_' ( i )  F") : dnat_scope.
*)

Definition max_f f := \max_(i < p) f i.

(*

( \big[max/O]_(i<p) f i).

Print max_f.

Notation "'\max_' ( i | P ) F" := (\big[maxn/0%N]_(i | P) F) 
  (at level 41, F at level 41, i, r at level 50,
   format "'\max_' ( i  |  P )  F") : dnat_scope.
Notation "'\max_' ( i ) F" := (\big[maxn/0%N]_(i) F) 
  (at level 41, F at level 41, i at level 50,
   format "'\max_' ( i )  F") : dnat_scope.
*)

Lemma desc_max_f0 :
forall f j, max_f f = maxn (f j) (\max_(i<p | (i != j)) f i).
Proof.
move => f j.
rewrite /max_f.
by apply: (bigD1 j ).
Qed.

Delimit Scope dnat_scope with Dn.

Lemma max_maxn:
forall m n, maxn m n = max m n.
Proof.
move=> m n; rewrite /maxn; case C: (m<n)%Dn.
by rewrite max_r ; [|move/leP:C=>C; omega] .
by rewrite max_l; [|move/leP:C=>C; omega].
Qed.

Lemma desc_max_f:
 forall f j, max_f f = max (f j) (\max_(i<p | (i != j)) f i).
Proof.
by move=> f j;
 rewrite -{1}max_maxn (desc_max_f0 f j).
Qed.

Lemma max_greater:
forall (f:I_(p)->nat) (k:I_(p)), 
(f k <= max_f f)%nat.
Proof.
move => f k.
rewrite (desc_max_f f k).
by apply le_max_l.
Qed.

(*we need for the next lemmas to compute the minimum of a vector with 
positive values; ticky because we don't have a neutral element with respect
to this opperation*)
(*
Lemma Rmin_assoc: forall x y z, Rmin x (Rmin y z) = Rmin (Rmin x y) z.
Proof.
move=> x y z.
destruct (Rle_or_lt x y).
replace (Rmin x y) with x ; [|unfold Rmin; case Rle_dec; auto with real].
 destruct (Rle_or_lt y z).
replace (Rmin y z) with y; [|unfold Rmin; case Rle_dec; auto with real].
replace (Rmin x y) with x;[|unfold Rmin; case Rle_dec; auto with real].
have H1: x<=z.
 apply Rle_trans with y; by fourier.
replace (Rmin x z) with x.
done.
unfold Rmin; case Rle_dec; auto with real.

replace (Rmin y z) with z; [done|unfold Rmin; case Rle_dec; auto with real].
replace (Rmin x y) with y; [|unfold Rmin; case Rle_dec; auto with real].
 destruct (Rle_or_lt y z).
replace (Rmin y z) with y; [|unfold Rmin; case Rle_dec; auto with real].
unfold Rmin; case Rle_dec; auto with real.
replace (Rmin y z) with z; [|unfold Rmin; case Rle_dec; auto with real].
have H3: z<x.
fourier.
unfold Rmin; case Rle_dec; auto with real.
Qed.
*)

Definition less_1 r := Rmin r 1.

Definition min_del (v:I_(p) ->R) :=
\big[Rmin/1]_(i) (less_1 (v i)).

Lemma minbig_mkcond : forall P v,
  \big[Rmin/R1]_(i <p | P i) ( (less_1 (v i))) =
     \big[Rmin/R1]_(i <p) (if P i then ( less_1 (v i)) else R1).
Proof.
unlock reducebig => P v.
 elim: (index_enum I_(p))  => //= i r -> .
case (P i).
done.
have H: forall r, foldr
  (fun (i0 : ordinal p) (x : R) => Rmin (if P i0 then  less_1 (v i0) else R1) x)
  R1 r <= R1 .
move => r0; elim :r0 => //=; [fourier|].
move => x s IH.
apply Rle_trans with (if P x then less_1 (v x) else 1).
apply Rmin_l.
case A:(P x).
rewrite /less_1; apply Rmin_r.
by right.
unfold Rmin at 2; case (Rle_dec R1 (foldr
     (fun (i0 : ordinal p) (x : R) =>
      Rmin (if P i0 then less_1 (v i0) else R1) x) R1 r) ) ; auto with real.
Qed.


Lemma minbig_split : forall  P F1 F2,
  \big[Rmin/R1]_(i <p | P i) (Rmin ( (F1 i))  ( (F2 i))) =
Rmin  (\big[Rmin/R1]_(i < p| P i) ( (F1 i))) (\big[Rmin/R1]_(i <p | P i) ( (F2 i))).
Proof.
unlock reducebig => P F1 F2.
elim: (index_enum I_(p)) => /= [|i r ->].
unfold Rmin; case (Rle_dec R1 R1); auto with real.
 case: (P i) => //=.
rewrite !Rmin_assoc.
congr (Rmin _ _).
rewrite -Rmin_assoc.

rewrite (Rmin_comm
( F2 i)
     (foldr
        (fun (i0 : ordinal p) (x : R) =>
         if P i0 then Rmin ( (F1 i0)) x else x) R1 r)).



by rewrite Rmin_assoc.
Qed.



Lemma minbigID : forall (a : set I_(p)) (P : I_(p) -> bool) F,
  \big[Rmin/R1]_(i<p | P i) (less_1 (F i))
    = Rmin (\big[Rmin/R1]_(i<p | P i && a i) (less_1 (F i))) 
        (\big[Rmin/R1]_(i<p | P i && ~~ a i) ( less_1(F i))).
Proof.
move=>  a P F.
rewrite !(minbig_mkcond _ F ).
 rewrite -minbig_split.
 apply: eq_bigr => i.
have H: less_1 (F i) <= 1.
rewrite /less_1; apply Rmin_r.
case: (a i).
rewrite //= andbT andbF =>*.
case (P i).
rewrite /Rmin; case (Rle_dec (less_1 (F i)) R1); auto with real.
unfold Rmin; case (Rle_dec R1 R1); auto with real.
rewrite //= andbF andbT =>*.
case (P i).
rewrite /Rmin; case (Rle_dec  R1 (less_1 (F i)) ); auto with real.
unfold Rmin; case (Rle_dec R1 R1); auto with real.
Qed.

Lemma minbig_seq1 : forall (i : I_(p)) F,

  \big[Rmin/R1]_(j <- Seq i) (less_1 (F j)) = less_1 (F i).
Proof. 
unlock reducebig => /=  i F.
have H: less_1 (F i) <= 1.
rewrite /less_1; apply Rmin_r.
apply sym_eq.
rewrite /Rmin; case (Rle_dec (less_1 (F i)) R1); auto with real.
Qed.

Lemma minbig_set1_eq : forall  (i : I_(p)) F,
  \big[Rmin/R1]_(j<p | i == j) ( less_1(F j)) = (less_1 (F i)).
Proof.
move=>  i F ; move: (filter_enum (set1 i) i) (FinType.enumP i).
rewrite set11 count_filter -big_filter; move: (filter _ _); case=> [|j []] //.
 rewrite mem_seq1 minbig_seq1.
by move/eqP->.
Qed.

Lemma minbig_set1 : forall (i : I_(p)) P F,
  P =1 set1 i -> \big[Rmin/R1]_(j<p | P j) (less_1 (F j)) = less_1 (F i).
Proof. move=>  i P F; move/(eq_bigl _ _)->; exact: minbig_set1_eq. Qed.

Lemma minbigD1 : forall j (P : I_(p) -> bool) F,

  P j -> \big[Rmin/R1]_(i<p | P i) (less_1 (F i))
    = Rmin (less_1 (F j))  (\big[Rmin/R1]_(i<p | P i && (i != j)) ( less_1(F i))).
Proof.
move=>  j P F Pj; rewrite (minbigID (set1 j));congr (Rmin _  _).
   apply: minbig_set1 => i.
by rewrite andbC; case: eqP => // <-.
by apply: eq_bigl => i; rewrite eq_sym.
Qed.

Lemma desc_min:forall v j, 

\big[Rmin/R1]_(i) less_1 (v i ) = Rmin (less_1 (v j))
    (\big[Rmin/R1]_(i<p|i!=j) less_1 (v i)).
Proof.
move=>v j .
by apply minbigD1 with (P:=(fun _  :I_(p)=> true)) (j:=j) (F:= (fun t => (v t))).
Qed.

 Lemma min_min: forall (v:I_(p)->R) i,
min_del v <= v i. 
Proof.
move=> v i ; rewrite /min_del (desc_min v i).
apply Rle_trans with (less_1 (v i)).
apply Rmin_l.
rewrite /less_1; apply Rmin_l.
Qed.

Lemma min_ge0:
forall (v:I_(p)->R),
(forall j, 0< v j) ->
0 < min_del v. 
Proof.
move=> v  H; rewrite /min_del .
unlock reducebig.
move: I_not_void.
elim (index_enum) => //=.
move => x s IH _.
case S:(seq0 !=s).
apply Rmin_Rgt_r; split .
rewrite /less_1; apply Rmin_Rgt_r; split;  [apply (H x)|apply Rlt_0_1 ] .
apply (IH S).
move/eqP:S =>S; rewrite -S //=.
apply Rmin_Rgt_r; split .
rewrite /less_1; apply Rmin_Rgt_r; split; [apply (H x)|apply Rlt_0_1 ] .
apply Rlt_0_1.
Qed.


Lemma ineq_sum_el:
forall v r,0<=r->(forall x, v x < r/INR p) -> 
\sum_(i<p) v i < r.
Proof.
move => f r Hr H.
have Heq: r =INR (card (index_enum I_(p)))*(r/INR p).
rewrite /index_enum.
have HeqsA: filter (setA I_(p)) (enum I_(p)) =1 setA I_(p) by apply filter_enum.
have HeqsE: filter (setA I_(p)) (enum I_(p)) = enum I_(p) by apply filter_setA.
rewrite HeqsE in HeqsA.
have Hc: (card (d:=I_(p)) (FinType.enum I_(p))) = (card (d:=I_(p)) (setA I_(p))).
by apply eq_card.
rewrite Hc.
rewrite card_ordinal.
rewrite /Rdiv ;field.
apply Rgt_not_eq.
by apply: lt_INR_0.
rewrite Heq.
unlock reducebig.
move: I_not_void.
move: (uniq_enum I_(p)).
rewrite /index_enum.
elim (enum) => //=.
move => x s IH IHand _.
move/andP :IHand =>IHand; elim IHand => Hdif Hun.

have Hcard: (card (d:=I_(p)) (setU1 x s)) = ((S O)+card (d:=I_(p)) s)%nat.
rewrite cardU1.
rewrite Hdif //=.
rewrite Hcard.
rewrite S_O_plus_INR .


case Hdifl: (seq0 != s).
rewrite Rmult_comm Rmult_plus_distr_l //= Rmult_1_r .
apply Rplus_lt_compat.
exact (H x).
rewrite Rmult_comm.
exact (IH Hun Hdifl).
move/eqP: Hdifl => Hdifl.

rewrite -Hdifl //=.
rewrite Rmult_comm Rmult_plus_distr_l Rmult_1_r.
apply Rplus_lt_le_compat .
exact (H x).
rewrite /Rdiv.

apply Rmult_le_pos.
apply Rmult_le_pos.
exact Hr.
apply Rlt_le.
apply Rinv_0_lt_compat.
by apply lt_INR_0 .
apply pos_INR.
Qed.

End rez.

Implicit Arguments max_f [p].
Implicit Arguments min_del [p].
Implicit Arguments min_ge0 [p].
Implicit Arguments  Rmax_le_f_le [p].
Implicit Arguments sum_le_f_le [p].
Implicit Arguments distr_plus_max [p].
Implicit Arguments ineq_sum_el [p].

(* things compile up to here :) *)
